               PROGRAM MESHPMAIN
**************    Last Revision on  2/06/92 BGT ************************
*
*              MESHPMAIN
*
************************************************************************
*23456789112345678921234567893123456789412345678951234567896123456789712
      
      use posttypes
      use glob_vars

      integer opt_sel 
      logical quit

      write(iout,10)

10    format(///,
     + 'Postprocessing program for the'/,
     + 'CONCAST Finite Element Analysis Program'//,
     + 'Developed by Glen T. Haegele and William R. Storkman, 1987'/,
     + 'Brian G. Thomas, 1989,1992'/,
     + 'Rodrigo A. Marin, August 8 1993'//)
c
c deciding on interactive input or read in from file 'filname'
c
      open(unit=iecho,file='postecho',status='unknown')

      quit = .FALSE.

      do while (.not. quit)
         call readmenu(1, opt_sel, iunit, iout)

         if (opt_sel .eq. 1) then
             call read_pagelength(page_length, iunit, iout)
             quit = .TRUE.
         else if (opt_sel .eq. 2) then
                  write(iout, *)
     +            'Sorry. This option is not implemented yet.'
c                 iunit = 40
c                 write(iout,20)
20                format(/,'Type in the name of input ',
     +                   'file. (up to 16 characters) ')
c                 read (5,320) filname
320               format(1a8)
c                 iout=7
c                 open(unit=7,file='postout',status='unknown')
c                 open(unit=40,file=filname,status='old')
c        else
c            iunit=5
         endif
      end do

      mesh_file_open = .FALSE.
      sol_file_open = .FALSE.

c Open Mesh File and read beginning 

      call open_mesh_file(imesh, iunit, iout)

c Initialize window

      call minmax(x,nnodes,xmin,xmax)
      call minmax(y,nnodes,ymin,ymax)

      xwmin = xmin
      ywmin = ymin
      xwmax = xmax
      ywmax = ymax

      x1st = xmin
      y1st = ymin
      x2st = xmax
      y2st = ymax

      call classify_line(x1st, y1st, x2st, y2st, tlinest,
     +                   mst, ast, bst, cst)

c Initialize graphics window

      call init_graphics(xmin, ymin, xmax, ymax)
      call reset_annotations()

c Assign variable name headers

      call head

c Repeat main loop until user quits

      quit = .FALSE.

      do while (.not. quit)
c
c Deciding on output type
c
         call readmenu(3, opt_sel, iunit, iout)

*23456789112345678921234567893123456789412345678951234567896123456789712
         if (opt_sel .eq. 1) then
             call print_tables(ibin, imesh, iunit, iout, sol_file_open)
         elseif (opt_sel .eq. 2) then
                 open(unit=icont,file='plotcon',status='unknown')

                 open(unit=itabl,file='plotits',status='unknown')

                 call graphic_interaction(STATE_NONGRAPH, opt_sel)

                 close(unit=icont,status='keep')
                 close(unit=itabl,status='keep') 

         elseif (opt_sel .eq. 3) then
                 call graphic_interaction(STATE_NONGRAPH, opt_sel)

         elseif (opt_sel .eq. 4) then
                 call graphic_interaction(STATE_NONGRAPH, opt_sel)

         elseif (opt_sel .eq. 5) then
                 write(iout, *)
     +           'Sorry. This option is not implemented yet.'
c                call postgr(t,xplot,xdist,tempvar,tle,sigma,
c    +                       casvel,tsol,tliq,
c    +                       nn,MAXN,nns,iunit,rtitle,mtitle)

         elseif (opt_sel .eq. 6) then
                 call graphic_interaction(STATE_NONGRAPH, opt_sel)

         elseif (opt_sel .eq. 7) then
                 quit = .TRUE.
         endif
      end do

      close(unit=ibin,status='keep')
      close(unit=imesh,status='keep')
      if(iunit.eq.40) close(unit=40,status='keep')
      if(iout.eq.7) close(unit=7,status='keep')
      close(unit=iecho,status='keep')
      write(iout,*)' Run complete'
      stop
      end
