*-----------------------------------------------------------------------
* annot.f
*-----------------------------------------------------------------------
*
* Subroutines to handle the annotation of plots.
*
* Author: Rodrigo A. Marin
* Date  : July 13 1993
*
* Modified for IBM's Fortran 90 xlf compiler. R. Marin 01/08/98
*-----------------------------------------------------------------------

*---------------------------------------------------------------------
      subroutine add_entity(ent_type)
*---------------------------------------------------------------------

      use posttypes
      use glob_vars

      include 'pubfunc.h'

      integer ent_type

      if (ent_type .eq. ENTTYPE_TEXT) then
          call add_text_entity()
      else if (ent_type .eq. ENTTYPE_LINE) then
          call add_line_entity()
      end if 

      return
      end

*---------------------------------------------------------------------
      subroutine add_line_entity
*---------------------------------------------------------------------

      use posttypes
      use glob_vars

      include 'pubfunc.h'

      character event_type*(MAXSTRINGLENGTH)
      character segment*(MAXSTRINGLENGTH)
      character annot_segname*(MAXSTRINGLENGTH)
      character action*(MAXSTRINGLENGTH)
      
      logical quit
      integer status


      real x0, y0, x00, y00
      real x1, y1
      real dummy


      
      if (nextannot .le. MAXNUMANNOT) then
          call hf_enable_selection_events('?locater', '?Picture')
               
          call hf_open_segment('?Picture/plot/annots/rubber line')

          call hf_qset_selectability('?Picture/plot', 'v')
          call hf_set_heuristics('quick moves')

          quit = .FALSE.

          call message(3)

          do while (.not. quit)
             call hf_await_event(event_type)
             call ltrim(event_type)

             if (event_type(1:strlen(event_type)) .eq.
     +           'selection') then
                 call hf_show_selection_source(segment, segment,
     +                                         action, status)

                 if (action(1:strlen(action)) .eq. 'v') then
                call hf_qset_selectability('?Picture/plot', '*^')
                     call hf_show_selection_position(x00, 
     +                                               y00, 
     +                                               dummy,
     +                                               dummy, 
     +                                               dummy,
     +                                               dummy)



                     call adjust_position(x00,y00,x0,y0)

                     call message(4)
                 else if (action(1:strlen(action)) .eq. '*') then
                          call hf_flush_geometry('.')
                          call hf_show_selection_position(x00, 
     +                    y00, dummy, dummy, dummy, dummy)

                            

                          call adjust_position(x00,y00,x1,y1)
                          call hf_insert_line(x0, y0, 0.0, x1, y1, 0.0)

                 else if (action(1:strlen(action)) .eq. '^') then
                          quit = .TRUE.
                          call hf_flush_geometry('.')
                          call hf_close_segment()

                          write(annot_segname, 100) nextannot
                      call hf_open_segment('?Picture/plot/annots/lines')
                          call hf_open_segment(annot_segname(1:
     +                                         strlen(annot_segname)))

                          call hf_insert_line(x0, y0, 0.0, x1, y1, 0.0)
                          call hf_close_segment()
                          call hf_close_segment()
                          call add_line_annotation(x0, y0, x1, y1)
                          call clear_messages()
                 end if
             end if
          end do

          call hf_qset_selectability('?Picture/plot', 'v') 
          call hf_disable_selection_events('?locater', '?Picture')
      else
          call rep_error(20)
      end if

      return
100   format('annotation line ', I3)
      end

*---------------------------------------------------------------------
      subroutine add_text_entity
*---------------------------------------------------------------------

      use posttypes
      use glob_vars

      include 'pubfunc.h'

      real posx, posy
      real x0,y0
      real dummy

      character prompt*(MAXSTRINGLENGTH)
      character segment*(MAXSTRINGLENGTH)
      character annot_segname*(MAXSTRINGLENGTH)
      character annotation*(MAXSTRINGLENGTH)

      prompt = 'Enter desired annotation'

      if (nextannot .le. MAXNUMANNOT) then
          annotation = read_string(READ_DEFPOSX, READ_DEFPOSY,
     +                             prompt, strlen(prompt), 
     +                             .TRUE., MAXSTRINGLENGTH, ' ')

          if (strlen(annotation) .gt. 0) then
              call message(2)
              call hf_open_segment('?Picture/plot/annots/text')

              call hf_get_selection(segment)
              call clear_messages()

              call hf_show_selection_position(posx, posy, dummy, 
     +                                        dummy, dummy, dummy)

              call adjust_position(posx,posy,x0,y0)
         
              write(annot_segname, 100) nextannot
              call add_text_annotation(x0, y0, annotation)

              call hf_open_segment(annot_segname(1:
     +                             strlen(annot_segname)))

              call hf_insert_text(x0, y0, 0.0, annotation)

              call hf_close_segment()

              call hf_close_segment()
         end if
      else
c         Call error message for maximum number of annotations reached
      end if

      return
100   format('annotation text ', I3)
      end

*---------------------------------------------------------------------
      subroutine annotate_plot
*---------------------------------------------------------------------

      use posttypes
      use glob_vars

      include 'pubfunc.h'

      integer option
      integer newmenu

      integer ent_type

      real ref_pt(2)

      logical quit

      curstate= STATE_ANNOT_00
      newmenu = 6

      ent_type = ENTTYPE_TEXT
      call display_annot_type(ent_type)

      call set_menu(newmenu, ref_pt)
      call read_menu(option)

      quit = .FALSE.

      do while (.not. quit)
         if (curstate .eq. STATE_ANNOT_00) then
             if (option .eq. 1) then
                 curstate = STATE_ANNOT_01
                 
                 ref_pt(1) = -1.0
                 ref_pt(2) = 1.0

                 newmenu = 9
             else if (option .eq. 2) then
                 curstate = STATE_ANNOT_02

                 ref_pt(1) = MENUBAR_OPT_WIDTH_FRAC * (option - 1)
     +                       - 1.0
                 ref_pt(2) = 1.0

                 newmenu = 10
             else if (option .eq. 3) then
                     quit = .TRUE.
                     curstate = STATE_NONGRAPH
                     newmenu = MENU_NO_MENU
             end if
         else if (curstate .eq. STATE_ANNOT_01) then
                  if (option .eq. 1) then
                      ent_type = ENTTYPE_TEXT
                  else if (option .eq. 2) then
                      ent_type = ENTTYPE_LINE
                  end if

                  call display_annot_type(ent_type)

                  curstate = STATE_ANNOT_00
                  newmenu = 6

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0
         else if (curstate .eq. STATE_ANNOT_02) then
                  if (option .eq. 1) then
                      call add_entity(ent_type)
                  else if (option .eq. 2) then
                      call delete_entity()
                  else if (option .eq. 3) then
                      call move_entity()
                  end if

                  curstate = STATE_ANNOT_00
                  newmenu = 6

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0
         end if

         call set_menu(newmenu, ref_pt)

         if (newmenu .ne. MENU_NO_MENU) then
             call read_menu(option)
             call clear_errmsg()
         end if
      end do

      call clear_annot_type()

      return
      end

*---------------------------------------------------------------------
      subroutine delete_entity
*---------------------------------------------------------------------

      use posttypes
      use glob_vars

      include 'pubfunc.h'

      character segment*(MAXSTRINGLENGTH)
      character indx_str*(MAXSTRINGLENGTH)

      integer annot_indx

      if (numannot .gt. 0) then
          call hf_qset_selectability('?Picture/plot/annots',
     +                               'window = off, text = on,
     +                                lines = on')

          call message(5)
          call hf_get_selection(segment)
          call clear_messages()

          call ltrim(segment)

          if (strlen(segment) .ge. strlen('annotation') + 2) 
     +    then
             if (segment(1:strlen('annotation')) .eq.
     +           'annotation') then
                 call hf_open_segment('?Picture/plot/annots')
                 if (segment(strlen('annotation') + 2:
     +                       strlen('annotation') + 5) .eq.
     +               'text') then
                      call hf_open_segment('text')
                 else
                      call hf_open_segment('lines')
                 end if

                 call hf_flush_contents(segment(1:strlen(segment)),
     +                                          'everything')

                 indx_str = segment(strlen('annotation') + 7:
     +                      strlen(segment))
                 read(indx_str, 200) annot_indx

                 call delete_annotation(annot_indx)

                 call hf_close_segment()
                 call hf_close_segment()
             end if
          end if
          call hf_qset_selectability('?Picture/plot/annots',
     +                               'window = off, 
     +                                text = off, 
     +                                lines = off')
      end if

      return
200   format(I3)
      end

*---------------------------------------------------------------------
      subroutine move_entity
*---------------------------------------------------------------------

      use posttypes
      use glob_vars

      include 'pubfunc.h'

      character segment*(MAXSTRINGLENGTH)
      character segname*(MAXSTRINGLENGTH)
      character indx_str*(MAXSTRINGLENGTH)

      integer annot_indx

      character event_type*(MAXSTRINGLENGTH)
      character action*(MAXSTRINGLENGTH)
      
      logical quit
      integer status

      real x0, y0
      real x00, y00
      real x1, y1
      real dummy
      
      if (numannot .gt. 0) then
          call hf_qset_selectability('?Picture/plot/annots',
     +                               'window = off, text = on,
     +                                lines = on')

          call message(6)
          call hf_get_selection(segname)
          call hf_qset_selectability('?Picture/plot/annots',
     +                               'window = off, 
     +                                text = off, 
     +                                lines = off')
          call ltrim(segname)

          if (strlen(segname) .ge. strlen('annotation') + 2) 
     +    then
             if (segname(1:strlen('annotation')) .eq.
     +           'annotation') then
                 call hf_open_segment('?Picture/plot/annots')

                 if (segname(strlen('annotation') + 2:
     +                       strlen('annotation') + 5) .eq.
     +               'text') then
                      call hf_open_segment('text')
                 else
                      call hf_open_segment('lines')
                 end if

                 indx_str = segname(strlen('annotation') + 7:
     +                      strlen(segname))
                 read(indx_str, 200) annot_indx

                 call hf_open_segment(segname)
                 call hf_flush_contents('.', 'lines, text')
                 call hf_close_segment()
                 call hf_close_segment()

                 call hf_enable_selection_events('?locater', '?Picture')
               
                 call hf_open_segment('move entity')

                 call hf_qset_selectability('?Picture/plot', 'v')
                 call hf_set_heuristics('quick moves')

                 if (annotation_tbl(annot_indx)%ent_type .eq. 
     +               ENTTYPE_TEXT) then
                     call hf_set_text_font('size = 0.015 sru')
                     call hf_set_text_alignment('<v')
                    call hf_insert_text(annotation_tbl(annot_indx)%posx,
     +                                  annotation_tbl(annot_indx)%posy,
     +                                  0.0, 
     +                                  annotation_tbl(annot_indx)%str) 
                 else
                   call hf_insert_line(annotation_tbl(annot_indx)%posx1,
     +                                 annotation_tbl(annot_indx)%posy1,
     +                                 0.0,
     +                                 annotation_tbl(annot_indx)%posx2,
     +                                 annotation_tbl(annot_indx)%posy2,
     +                                 0.0)
                 end if

                 quit = .FALSE.

                 call message(7)

                 do while (.not. quit)
                    call hf_await_event(event_type)
                    call ltrim(event_type)

                    if (event_type(1:strlen(event_type)) .eq.
     +                  'selection') then
                        call hf_show_selection_source(segment, segment,
     +                                                action, status)

                        if (action(1:strlen(action)) .eq. 'v') then
                            call hf_qset_selectability('?Picture/plot', 
     +                                                 '*^')
                            call hf_show_selection_position(x00, 
     +                                                      y00, 
     +                                                      dummy,
     +                                                      dummy,
     +                                                      dummy, 
     +                                                      dummy)

                            call adjust_position(x00,y00,x0,y0)

                        else if (action(1:strlen(action)) .eq. '*') then
                                call hf_flush_contents('.', 'text, 
     +                                                       lines')
                                call hf_show_selection_position(x00,y00, 
     +                                                          dummy, 
     +                                                          dummy, 
     +                                                          dummy, 
     +                                                          dummy)

                                call adjust_position(x00,y00,x1,y1)
                           
                                if (annotation_tbl(annot_indx)%ent_type 
     +                              .eq. ENTTYPE_TEXT) then
                                    call hf_insert_text(x1, y1, 0.0,
     +                                   annotation_tbl(annot_indx)%str) 
                                else
                                    call hf_insert_line(x1 - x0 + 
     +                                 annotation_tbl(annot_indx)%posx1,
     +                                                  y1 - y0 +
     +                                 annotation_tbl(annot_indx)%posy1,
     +                                                  0.0,
     +                                                  x1 - x0 +
     +                                 annotation_tbl(annot_indx)%posx2,
     +                                                  y1 - y0 +
     +                                 annotation_tbl(annot_indx)%posy2,
     +                                                  0.0)
                                end if
                        else if (action(1:strlen(action)) .eq. '^') then
                                 quit = .TRUE.
                                 call hf_flush_contents('.', 'lines, 
     +                                                        text')
                                 call hf_close_segment()

                                 if (annotation_tbl(annot_indx)%ent_type
     +                               .eq. ENTTYPE_TEXT) then
                                     call hf_open_segment('text')
                                 else
                                     call hf_open_segment('lines')
                                 end if

                                 call hf_open_segment(segname)

                                 if (annotation_tbl(annot_indx)%ent_type
     +                               .eq. ENTTYPE_TEXT) then
                                    call hf_insert_text(x1, y1, 0.0,
     +                                   annotation_tbl(annot_indx)%str) 
                                   annotation_tbl(annot_indx)%posx = x1
                                   annotation_tbl(annot_indx)%posy = y1
                                 else
                                    call hf_insert_line(x1 - x0 + 
     +                                 annotation_tbl(annot_indx)%posx1,
     +                                                  y1 - y0 +
     +                                 annotation_tbl(annot_indx)%posy1,
     +                                                  0.0,
     +                                                  x1 - x0 +
     +                                 annotation_tbl(annot_indx)%posx2,
     +                                                  y1 - y0 +
     +                                 annotation_tbl(annot_indx)%posy2,
     +                                                  0.0)
                                    annotation_tbl(annot_indx)%posx1 = 
     +                              x1 - x0 + 
     +                              annotation_tbl(annot_indx)%posx1

                                    annotation_tbl(annot_indx)%posy1 = 
     +                              y1 - y0 + 
     +                              annotation_tbl(annot_indx)%posy1

                                    annotation_tbl(annot_indx)%posx2 = 
     +                              x1 - x0 + 
     +                              annotation_tbl(annot_indx)%posx2

                                    annotation_tbl(annot_indx)%posy2 = 
     +                              y1 - y0 + 
     +                              annotation_tbl(annot_indx)%posy2
                                 end if

                                 call hf_close_segment()
                                 call hf_close_segment()
                                 call clear_messages()
                        end if
                    end if
                 end do

                 call hf_qset_selectability('?Picture/plot', 'v') 
                 call hf_disable_selection_events('?locater', 
     +                                            '?Picture')
                 
                 call hf_close_segment()
             end if
          end if
      end if
      
      return
200   format(I3)
      end
