      subroutine asklab(ptitle, nodplot, nodnum, elplot, boundplt,
     +                  contlabl, intlab, iunit, iout, iecho)

      include 'postconst.h'
      include 'pubfunc.h'
c
*-----------------------------------------------------------------------
*
*        Subroutine to input information on MESH PLOTTING options
*
*-----------------------------------------------------------------------
c
      character nodplot*1,nodnum*1,elplot*1,boundplt*1,contlabl*1,
     +          ptitle*(MAXSTRINGLENGTH)
      integer intlab, iunit,iecho,iout
c
      character options2(2)*(MAXOPTLENGTH), prompt*(MAXPROMPTLENGTH)
      integer i, option, default
      logical quit
c
      data options2 /'y', 'n'/
      quit = .FALSE.

      do while (.not. quit)
         call readmenu(2, option, iunit, iout)

         if (option .eq. 1) then
                  if (nodplot .eq. options2(1)) then
                      default = 1 
                  else
                      default = 2 
                  end if

                  prompt = 'Plot Nodes? (y/n) '
                  call readopt(2, options2, prompt, strlen(prompt)+1,
     +                         .TRUE., default, option, iunit, iout)
                  nodplot = options2(option)
                  
         else if (option .eq. 2) then
                  if (nodnum .eq. options2(1)) then
                      default = 1
                  else
                      default = 2
                  end if

                  prompt = 'Plot Node Numbers? (y/n) '
                  call readopt(2, options2, prompt, strlen(prompt)+1,
     +                         .TRUE., default, option, iunit, iout)
                  nodnum = options2(option)
                  
         else if (option .eq. 3) then
                  if (elplot .eq. options2(1)) then
                      default = 1
                  else
                      default = 2
                  end if

                  prompt = 'Plot Elements? (y/n)'
                  call readopt(2, options2, prompt, strlen(prompt)+1, 
     +                         .TRUE., default, option, iunit, iout)
                  elplot = options2(option)
                  
         else if (option .eq. 4) then
                  if (boundplt .eq. options2(1)) then
                      default = 1
                  else
                      default = 2
                  end if

                  prompt = 'Plot Domain Boundaries? (y/n)'
                  call readopt(2, options2,
     +                         prompt, strlen(prompt)+1, 
     +                         .TRUE., default, option, iunit, iout)
                  boundplt = options2(option)
                  
         else if (option .eq. 5) then
                  if (boundplt .eq. options2(1)) then
                      default = 1
                  else
                      default = 2
                  end if

                  prompt = 'Label Contours? (y/n)' 
                  call readopt(2, options2,
     +                         prompt, strlen(prompt)+1, 
     +                         .TRUE., default, option, iunit, iout)
                  contlabl = options2(option)
                  
         else if (option .eq. 6) then
                  prompt = 'Increment between labels: '
                  intlab = readinteger(prompt, strlen(prompt)+1, .TRUE.,
     +                                 intlab, iunit, iout)
         else if (option .eq. 7) then
                  quit = .TRUE.
         end if
      end do     
      return
100   format(A)
200   format(A, $)
      end

*-----------------------------------------------------------------------
      subroutine setplotconfig(newtitle, newnodplot, newnodnum, 
     +                         newelplot, newboundplt, newcontlabl, 
     +                         new_wallplot, newintlab, 
     +                         new_disp_border_plot, dummy)
*-----------------------------------------------------------------------
* Sets the new default values for the plot configuration variables.
*
* Author: Rodrigo A. Marin
* Date  : December 30 1992
*-----------------------------------------------------------------------

      use glob_vars 

      character newtitle*(MAXSTRINGLENGTH), newnodplot*1, newnodnum*1,
     +          newelplot*1, newboundplt*1, newcontlabl*1,
     +          new_wallplot*1, new_disp_border_plot*1

      integer newintlab
      integer dummy

      mtitle = newtitle
      nodplot = newnodplot
      nodnum = newnodnum
      elplot = newelplot
      boundplt = newboundplt
      contlabl = newcontlabl
      wallplot = new_wallplot
      intlab = newintlab
      disp_border_plot = new_disp_border_plot

      return
      end      

