      subroutine assign (tempvar,t,ut,vt,sigma,epsln,evp,prst2,
     +        seff,epefft,eeff,epdot,uts,ratio,e0,fa,tle,
     +        elastic,eflow,dmgcrt,emod,ctime,
     +        nn,nns,itraknum)
************************************************************************
*
*        Subroutine to assign chosen variable to tempvar
*
************************************************************************
c
      double precision t(nn), ut(nns), vt(nns), prst2(4,nns),
     + sigma(4,nns), epsln(4,nns),evp(4,nns),seff(nns),
     + epefft(nns), eeff(nns), epdot(nns),
     + uts(nns), ratio(nns), e0(nns), fa(nns), tle(nns),
     + elastic(4,nns),eflow(4,nns),dmgcrt(4,nns),emod(nns),
     + tempvar(nn),ctime
      integer nn,nns,itraknum
c
*-----------------------------------------------------------------------
c   Nodal Temperatures
      if (itraknum .eq. 1) then
         do 10 i=1,nn
10       tempvar(i) = t(i)
*-----------------------------------------------------------------------
c   U-displacement
      elseif (itraknum .eq. 2) then
         do 20 i=1,nns
20       tempvar(i) = ut(i)
*-----------------------------------------------------------------------
c     V-displacement
      elseif (itraknum .eq. 3) then
         do 30 i=1,nns
30       tempvar(i) = vt(i)
*-----------------------------------------------------------------------
c     X-Stress
      elseif (itraknum .eq. 4) then
         do 40 i=1,nns
40       tempvar(i) = sigma(1,i)
*-----------------------------------------------------------------------
c     Y-Stress
      elseif (itraknum .eq. 5) then
         do 50 i=1,nns
50       tempvar(i) = sigma(2,i)
*-----------------------------------------------------------------------
c     Z-Stress
      elseif (itraknum .eq. 6) then
         do 60 i=1,nns
60       tempvar(i) = sigma(3,i)
*-----------------------------------------------------------------------
c     XY-Stress
      elseif (itraknum .eq. 7) then
         do 70 i=1,nns
70       tempvar(i) = sigma(4,i)
*-----------------------------------------------------------------------
c     X-Strain (total)
      elseif (itraknum .eq. 8) then
         do 80 i=1,nns
80       tempvar(i) = epsln(1,i)
*-----------------------------------------------------------------------
c     Y-Strain (total)
      elseif (itraknum .eq. 9) then
         do 90 i=1,nns
90       tempvar(i) = epsln(2,i)
*-----------------------------------------------------------------------
c     Z-Strain (total)
      elseif (itraknum .eq. 10) then
         do 100 i=1,nns
100      tempvar(i) = epsln(3,i)
*-----------------------------------------------------------------------
c     XY-Strain (total)
      elseif (itraknum .eq. 11) then
         do 110 i=1,nns
110       tempvar(i) = epsln(4,i)
*-----------------------------------------------------------------------
c     X-Plastic Strain
      elseif (itraknum .eq. 12) then
         do 120 i=1,nns
120       tempvar(i) = evp(1,i)
*-----------------------------------------------------------------------
c     Y-Plastic Strain
      elseif (itraknum .eq. 13) then
         do 130 i=1,nns
130       tempvar(i) = evp(2,i)
*-----------------------------------------------------------------------
c     Z-Plastic Strain
      elseif (itraknum .eq. 14) then
         do 140 i=1,nns
140       tempvar(i) = evp(3,i)
*-----------------------------------------------------------------------
c     XY-Plastic Strain
      elseif (itraknum .eq. 15) then
         do 150 i=1,nns
150       tempvar(i) = evp(4,i)
*-----------------------------------------------------------------------
c     Principal Stress 1
      elseif (itraknum .eq. 16) then
         call prst(sigma,prst2,nns,nn)
         do 160 i=1,nns
160       tempvar(i) = prst2(1,i)
*-----------------------------------------------------------------------
c     Principal Stress 2
      elseif (itraknum .eq. 17) then
         call prst(sigma,prst2,nns,nn)
         do 170 i=1,nns
170      tempvar(i) = prst2(2,i)
*-----------------------------------------------------------------------
c     Principal Stress 3
      elseif (itraknum .eq. 18) then
         call prst(sigma,prst2,nns,nn)
         do 180 i=1,nns
180      tempvar(i) = prst2(3,i)
*-----------------------------------------------------------------------
c     Principal Shear Stress
      elseif (itraknum .eq. 19) then
         call prst(sigma,prst2,nns,nn)
         do 190 i=1,nns
190      tempvar(i) = prst2(4,i)
*-----------------------------------------------------------------------
c     Principal Strain 1 (total)
      elseif (itraknum .eq. 20) then
         call prst(epsln,prst2,nns,nn)
         do 200 i=1,nns
200      tempvar(i) = prst2(1,i)
*-----------------------------------------------------------------------
c     Principal Strain 2 (total)
      elseif (itraknum .eq. 21) then
         call prst(epsln,prst2,nns,nn)
         do 210 i=1,nns
210      tempvar(i) = prst2(2,i)
*-----------------------------------------------------------------------
c     Principal Strain 3 (total)
      elseif (itraknum .eq. 22) then
         call prst(epsln,prst2,nns,nn)
         do 220 i=1,nns
220      tempvar(i) = prst2(3,i)
*-----------------------------------------------------------------------
c     Principal Shear Strain (total)
      elseif (itraknum .eq. 23) then
         call prst(epsln,prst2,nns,nn)
         do 230 i=1,nns
230      tempvar(i) = prst2(4,i)
*-----------------------------------------------------------------------
c     Principal Plastic Strain 1
      elseif (itraknum .eq. 24) then
         call prst(evp,prst2,nns,nn)
         do 240 i=1,nns
240      tempvar(i) = prst2(1,i)
*-----------------------------------------------------------------------
c     Principal Plastic Strain 2
      elseif (itraknum .eq. 25) then
         call prst(evp,prst2,nns,nn)
         do 250 i=1,nns
250      tempvar(i) = prst2(2,i)
*-----------------------------------------------------------------------
c     Principal Plastic Strain 3
      elseif (itraknum .eq. 26) then
         call prst(evp,prst2,nns,nn)
         do 260 i=1,nns
260      tempvar(i) = prst2(3,i)
*-----------------------------------------------------------------------
c     Principal Plastic Shear Strain
      elseif (itraknum .eq. 27) then
         call prst(evp,prst2,nns,nn)
         do 270 i=1,nns
270      tempvar(i) = prst2(4,i)
*-----------------------------------------------------------------------
c     Effective Stress
      elseif (itraknum .eq. 28) then
         do 280 i=1,nns
280      tempvar(i) = seff(i)
*-----------------------------------------------------------------------
c     Effective Plastic Strain
      elseif (itraknum .eq. 29) then
         do 290 i=1,nns
290      tempvar(i) = epefft(i)
*-----------------------------------------------------------------------
c     Effective Elastic Strain
      elseif (itraknum .eq. 30) then
         do 300 i=1,nns
300      tempvar(i) = eeff(i)
*-----------------------------------------------------------------------
c     Plastic Strain Rate
      elseif (itraknum .eq. 31) then
         do 310 i=1,nns
310      tempvar(i) = epdot(i)
*-----------------------------------------------------------------------
c     Ultimate Tensile Strength
      elseif (itraknum .eq. 32) then
         do 320 i=1,nns
320      tempvar(i) = uts(i)
*-----------------------------------------------------------------------
c     Stress/UTS
      elseif (itraknum .eq. 33) then
         do 330 i=1,nns
330      tempvar(i) = ratio(i)
*-----------------------------------------------------------------------
c     Thermal Strain
      elseif (itraknum .eq. 34) then
         do 340 i=1,nns
340      tempvar(i) = e0(i)
*-----------------------------------------------------------------------
c     Fraction Alpha Transformed
      elseif (itraknum .eq. 35) then
         do 350 i=1,nns
350      tempvar(i) = fa(i)
*-----------------------------------------------------------------------
c     Thermal Linear Expansion Coefficient
      elseif (itraknum .eq. 36) then
         do 360 i=1,nns
360      tempvar(i) = tle(i)
*-----------------------------------------------------------------------
c     Hydrostatic Stresses
      elseif (itraknum .eq. 37) then
         do 370 i=1,nns
370      tempvar(i) = (sigma(1,i)+sigma(2,i)+sigma(3,i))/3.0
*-----------------------------------------------------------------------
c     Elastic X 
      elseif (itraknum .eq. 39) then
         do 390 i=1,nns
390      tempvar(i) =  elastic(1,i)
*-----------------------------------------------------------------------
c     Elastic Y
      elseif (itraknum .eq. 40) then
         do 400 i=1,nns
400      tempvar(i) =  elastic(2,i)
*-----------------------------------------------------------------------
c     Elastic Z
      elseif (itraknum .eq. 41) then
         do 410 i=1,nns
410      tempvar(i) =  elastic(3,i)
*-----------------------------------------------------------------------
c     Elastic XY
      elseif (itraknum .eq. 42) then
         do 420 i=1,nns
420      tempvar(i) =  elastic(4,i)
*-----------------------------------------------------------------------
c     Flow Strain X  
      elseif (itraknum .eq. 43) then
         do 430 i=1,nns
430      tempvar(i) =  eflow(1,i) 
*-----------------------------------------------------------------------
c     Flow Strain Y 
      elseif (itraknum .eq. 44) then
         do 440 i=1,nns
440      tempvar(i) =  eflow(2,i)
*-----------------------------------------------------------------------
c     Flow Strain Z 
      elseif (itraknum .eq. 45) then
         do 450 i=1,nns
450      tempvar(i) =  eflow(3,i)
*-----------------------------------------------------------------------
c     Flow Strain XY
      elseif (itraknum .eq. 46) then
         do 460 i=1,nns
460      tempvar(i) =  eflow(4,i)
*-----------------------------------------------------------------------
c     Damage Criteria 1 
      elseif (itraknum .eq. 47) then
         do 470 i=1,nns
470      tempvar(i) =  dmgcrt(1,i) 
*-----------------------------------------------------------------------
c     Damage Criteria 2
      elseif (itraknum .eq. 48) then
         do 480 i=1,nns
480      tempvar(i) =  dmgcrt(2,i)
*-----------------------------------------------------------------------
c     Damage Criteria 3
      elseif (itraknum .eq. 49) then
         do 490 i=1,nns
490      tempvar(i) =  dmgcrt(3,i)
*-----------------------------------------------------------------------
c     Damage Criteria 4
      elseif (itraknum .eq. 50) then
         do 500 i=1,nns
500      tempvar(i) =  dmgcrt(4,i)
*-----------------------------------------------------------------------
c     Elastic Modulus
      elseif (itraknum .eq. 51) then
         do 510 i=1,nns
510      tempvar(i) = emod(i) 
*-----------------------------------------------------------------------

      endif
      return
      end
