      subroutine conlabl1(autcontval,mancontval,iunit,iout,contlabl,
     +                   intlab,charlabl, conttype,numautcont,
     +                   nummancont, tmin, tmax,ychoose,ymaxtemp)
***************** Last revision  4/22/89 *******************************
*
*        Subroutine to input info, labels, and plot contours
*
*-----------------------------------------------------------------------
c23456789112345678921234567893123456789412345678951234567896123456789712
c
      implicit double precision (a-h,o-z)

      include 'postconst.h'
      include 'pubfunc.h'

      double precision autcontval(MAXCONTOURS)
      double precision mancontval(MAXCONTOURS)
      double precision tmin, tmx
      integer iunit,iout,iecho,numautcont,nummancont,intlab
      integer newnumcont
      integer i
      
      logical err
      logical quit 

      character contlabl*1,conttype*1,
     +          ychoose*1,ymaxtemp*1
      character charlabl(MAXCONTOURS)*1

      character prompt*(MAXPROMPTLENGTH)
      character contvalstr*(MAXSTRINGLENGTH)
c

      if (conttype .eq. 'a') then
          call readnumcont(numautcont)
      else 
         newnumcont = nummancont
         prompt = ' '

         if (nummancont .gt. 0) then
             i = 1
             prompt = '['

             do while (i .le. nummancont)
                if (i .eq. 1) then
                    write(contvalstr, 500) mancontval(i)
                else
                    write(contvalstr, 600) mancontval(i)
                end if
 
                prompt = prompt(1:strlen(prompt)) // contvalstr
                i = i + 1
             end do

             prompt = prompt(1:strlen(prompt)) // ']: '
         end if

         quit = .FALSE.

         do while (.not. quit)
            prompt = 'Enter desired contour values'

            call read_ndouble(READ_DEFPOSX, READ_DEFPOSY,
     +                        prompt, strlen(prompt), MAXCONTOURS, 
     +                       .TRUE., .FALSE., nummancont, mancontval, 
     +                       newnumcont, mancontval, '(F12.3)', ' ')

            if ((newnumcont .eq. 0) .and. (nummancont .eq. 0)) then
                call rep_error(19)
            else
               if (newnumcont .eq. 0) then
                   newnumcont = nummancont
               end if

               i = 1
               err = .FALSE.

               do while ((i .le. newnumcont) .and. (.not. err))
                  if ((tmin .gt. mancontval(i)) .or. 
     +                (tmax .lt. mancontval(i))) 
     +            then
                      call reperror(4, iout)
                      err = .TRUE.
                  end if
                  i = i + 1
               end do

               quit = .not. err
            end if
         end do

         nummancont = newnumcont
      endif

      return
500   format(f14.5)
600   format(',', f14.5)
      end

*-----------------------------------------------------------------------
      subroutine readnumcont(numcont)
c
*-----------------------------------------------------------------------
*     Subroutine to read in the desired number of contours to be plotted
*
* Author: Rodrigo Marin
* Date  : October 28 1992
*-----------------------------------------------------------------------

      include 'postconst.h'
      include 'pubfunc.h'

      integer numcont
      integer newnumcont

      character prompt*(MAXPROMPTLENGTH)

      logical quit

      quit = .FALSE.

      write(prompt, 200) MAXCONTOURS

      do while (.not. quit)
         newnumcont = read_integer(READ_DEFPOSX, READ_DEFPOSY,
     +                             prompt, strlen(prompt), .TRUE.,
     +                             .FALSE., numcont, ' ')

         quit = (newnumcont .ge. 0) .and. (newnumcont .le. MAXCONTOURS)

         if (.not. quit) then
             call rep_error(19)
         else
             call clear_errmsg()
         end if
      end do

      numcont = newnumcont
      return
200   format('Number of desired contours (Max. ', I4, ')')
      end
