      subroutine conplot(displaced, plot_mold_wall)
***************** Last revision  01/02/93 *******************************
*            Contour plotting driver subroutine
*
************************************************************************
c23456789112345678921234567893123456789412345678951234567896123456789712
c

      use posttypes
      use glob_vars

      include 'pubfunc.h'

      logical displaced
      logical plot_mold_wall

      logical quit
      logical err
      logical time_set
      integer option
      integer newmenu
      integer i
      integer numautcont
      integer nummancont
      integer numcont
      
      integer invalid(1)
      integer defvar(1)
      
      character prompt*(MAXPROMPTLENGTH)
      character hcopyfname*(MAXSTRINGLENGTH)

      real ref_pt(2)

      numvar = 1
      defvar(1) = 1
      invalid(1) = 38
      conttype = 'a'

      itraknum(1) = 1

      if (.not. sol_file_open) then
          call open_solution_file(ibin, iunit, iout)
      end if

      write(iout, *)
      write(iout, *) 'Please use the graphics window'
      write(iout, *)

      call clear_messages()
        
      call find_iteration(timetype,time,newtime,
     +                    lastzpos,newzpos,casvel,
     +                    lastitnum,newitnum,
     +                    t,ut,vt,sigma,epsln,evp,seff,
     +                    epefft,eeff,epdot,uts,ratio,
     +                    e0,fa,tle,elastic,eflow,dmgcrt,emod,
     +                    ctime,nn,nns,itnum,
     +                    zpos, ibin,iout)

      timetype = 't'

c-----------------------------------------------------------------------
c        Assign tempvar to desired plot variable
      call assign (tempvar,t,ut,vt,sigma,epsln,evp,
     +             prst2,seff,epefft,eeff,epdot,uts,
     +             ratio,e0,fa,tle,elastic,eflow,
     +             dmgcrt, emod,ctime,nn,nns,
     +             itraknum)
c-----------------------------------------------------------------------
c        Determine location and value of max and min variables
      call minmax2(tempvar,tmax,tmin,imax,imin,nn)
c-----------------------------------------------------------------------

      nummancont = 2
      mancontval(1) = tmin
      mancontval(2) = tmax

      numautcont = 10 
      numcont = numautcont

      if (.not. displaced) then
          i = 1

          do while (i .le. nn)
             xdist(i) = x(i)
             ydist(i) = y(i)
             
             i = i + 1
          end do
c  Determine largest and smallest x and y values in mesh
          call minmax(xdist,nnodes,xmin,xmax)
          call minmax(ydist,nnodes,ymin,ymax)
      else
          call minmax(x, nnodes, xmin, xmax)
          call minmax(y, nnodes, ymin, ymax)
      end if

      quit = .FALSE.
      err = .FALSE.

      call setplotconfig(mtitle, 'y', 'n', 'n', 'y', 'y', 'n',
     +                   intlab, disp_border_plot, 1)

c-----------------------------------------------------------------------
c        Assign headers and input which binout variables to plot
c-----------------------------------------------------------------------
      call head
    
      close(unit=icont,status='keep')

      curstate = STATE_CONPLOT_00
      newmenu = 1

      ref_pt(1) = -1.0
      ref_pt(2) = 1.0
 
      call set_menu(newmenu, ref_pt)
      call read_menu(option)

      do while (.not. quit)
         if (curstate .eq. STATE_CONPLOT_00) then
             if (option .eq. 1) then
                 curstate = STATE_CONPLOT_01

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0 

                  newmenu = 2
             else if (option .eq. 2) then
                      curstate = STATE_CONPLOT_02

                      ref_pt(1) = MENUBAR_OPT_WIDTH_FRAC * (option - 1) 
     +                            - 1.0
                      ref_pt(2) = 1.0

                      newmenu = 3
             else if (option .eq. 3) then
                      call read_variables(1, 1, invalid, 1, defvar,
     +                                    numvar, itraknum)

c-----------------------------------------------------------------------
c        Assign tempvar to desired plot variable
                      call assign (tempvar,t,ut,vt,sigma,epsln,evp,
     +                             prst2,seff,epefft,eeff,epdot,uts,
     +                             ratio,e0,fa,tle,elastic,eflow,dmgcrt,
     +                             emod,ctime,nn,nns,
     +                             itraknum)
c-----------------------------------------------------------------------
c        Determine location and value of max and min variables
                      call minmax2(tempvar,tmax,tmin,imax,imin,nn)
c-----------------------------------------------------------------------

                      curstate = STATE_CONPLOT_00
                      newmenu = 1

                      ref_pt(1) = -1.0
                      ref_pt(2) = 1.0
             else if (option .eq. 4) then
                      curstate = STATE_CONPLOT_03

                      ref_pt(1) = MENUBAR_OPT_WIDTH_FRAC * (option - 1) 
     +                            - 1.0
                      ref_pt(2) = 1.0

                      newmenu = 4
             else if (option .eq. 5) then
                      call annotate_plot()
                      curstate = STATE_CONPLOT_00

                      ref_pt(1) = -1.0
                      ref_pt(2) = 1.0

                      newmenu = 1
             else if (option .eq. 6) then
                      curstate = STATE_CONPLOT_06

                      ref_pt(1) = MENUBAR_OPT_WIDTH_FRAC * (option - 1) 
     +                            - 1.0
                      ref_pt(2) = 1.0

                      newmenu = 7
             else if (option .eq. 7) then
                      curstate = STATE_CONPLOT_04

                      ref_pt(1) = MENUBAR_OPT_WIDTH_FRAC * (option - 1) 
     +                            - 1.0
                      ref_pt(2) = 1.0

                      newmenu = 5
             end if
         else if (curstate .eq. STATE_CONPLOT_01) then
                  if (option .eq. 1) then
                      if (nodplot .eq. 'y') then
                          nodplot = 'n'
                      else
                          nodplot = 'y'
                      end if
                  else if (option .eq. 2) then
                           if (nodnum .eq. 'y') then
                               nodnum = 'n'
                           else
                               nodnum = 'y'
                           end if
                  else if (option .eq. 3) then
                           if (elplot .eq. 'y') then
                               elplot = 'n'
                           else
                               elplot = 'y'
                            end if
                  else if (option .eq. 4) then
                           if (boundplt .eq. 'y') then
                               boundplt = 'n'
                           else
                               boundplt = 'y'
                           end if
                  else if (option .eq. 5) then
                           if (wallplot .eq. 'y') then
                               wallplot = 'n'
                           else
                               wallplot = 'y'
                           end if
                  else if (option .eq. 7) then
                           write(prompt, 200) defmag

                           defmag = read_double(READ_DEFPOSX,
     +                                          READ_DEFPOSY,
     +                                          prompt, strlen(prompt),
     +                                          .TRUE., .FALSE., defmag, 
     +                                          '(F8.3)', ' ')
                  end if

                  curstate = STATE_CONPLOT_00
                  newmenu = 1

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0
         else if (curstate .eq. STATE_CONPLOT_02) then
                  if (option .ne. MENU_NO_OPT_SEL) then
                      call ask_iter(option, time, newtime, lastzpos, 
     +                              newzpos, casvel, lastitnum, 
     +                              newitnum,iunit, iout, ibin, 
     +                              timetype)

                      if (option .ne. 4) then
                          call find_iteration(timetype,time,newtime,
     +                                        lastzpos,newzpos,casvel,
     +                                        lastitnum,newitnum,
     +                                        t,ut,vt,sigma,epsln,evp,
     +                                        seff,epefft,eeff,epdot,
     +                                        uts,ratio,e0,fa,tle,
     +                                        elastic,eflow,dmgcrt,emod,
     +                                        ctime,nn,nns,itnum,zpos,
     +                                        ibin,iout)
                          write(iout, *)
                          write(iout, *) 
     +                    'Plot will be done for the following data:'
                          write(iout, *)
                          write(iout, 300)'Iteration : ', itnum
                          write(iout, 400)'Time      : ', ctime
                          write(iout, 400)'Z-position: ', zpos

c-----------------------------------------------------------------------
c        Assign tempvar to desired plot variable
                         call assign (tempvar,t,ut,vt,sigma,epsln,evp,
     +                             prst2,seff,epefft,eeff,epdot,uts,
     +                             ratio,e0,fa,tle,elastic,eflow,
     +                             dmgcrt, emod,ctime,nn,nns,
     +                             itraknum)

c-----------------------------------------------------------------------
c        Determine location and value of max and min variables
                         call minmax2(tempvar,tmax,tmin,imax,imin,nn)
c-----------------------------------------------------------------------
                      end if
                  end if

                  curstate = STATE_CONPLOT_00
                  newmenu = 1

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0
         else if (curstate .eq. STATE_CONPLOT_03) then
                  if (option .eq. 1) then
                      conttype = 'a'
                  else if (option .eq. 2) then
                           conttype = 'v'
                  else if (option .eq. 3) then
                           if (contlabl .eq. 'y') then
                               contlabl = 'n'
                           else
                               contlabl = 'y'
                           end if
                  else if (option .eq. 4) then
                           call read_label_increment(intlab, intlab)
                  end if

                  if ((option .eq. 1) .or. (option .eq. 2)) then
c-----------------------------------------------------------------------
c        Display minimum and maximum possible contour values

                      write(iout, *)
                      write(iout, 400) 
     +                'Minimum possible contour value: ', tmin
                      write(iout, 400)
     +                'Maximum possible contour value: ', tmax
                      write(iout, *)

                      call conlabl1(autcontval, mancontval,iunit, iout, 
     +                              contlabl,intlab, charlabl, conttype,
     +                              numautcont, nummancont, tmin,
     +                              tmax, ychoose, ymaxtemp)
                  end if

                  curstate = STATE_CONPLOT_00
                  newmenu = 1

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0
         else if (curstate .eq. STATE_CONPLOT_04) then
                  call window_definition(option)

                  curstate = STATE_CONPLOT_00
                  newmenu = 1

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0
         else if (curstate .eq. STATE_CONPLOT_06) then
                  curstate = STATE_CONPLOT_00
                  newmenu = 1

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0

                  if (option .eq. 1) then
                      call update_conplot(displaced, plot_mold_wall, 
     +                                    nummancont, numautcont)
                  else if (option .eq. 2) then
                      call clear_plot_area()
                      call clear_info_area()
                  else if (option .eq. 3) then
                           call generate_hardcopy(iunit, iout, 
     +                                            hcopyfname)
                           call save_contour_data(hcopyfname, numcont)
                  else if (option .eq. 4) then
                           call generate_pict_file(iunit, iout,
     +                                             hcopyfname)
                           call save_contour_data(hcopyfname, numcont)
                  else if (option .eq. 5) then
                           quit = .TRUE.
                           curstate =  STATE_NONGRAPH
                           newmenu = MENU_NO_MENU
                  end if
         end if
             
         call set_menu(newmenu, ref_pt)

         if (newmenu .ne. MENU_NO_MENU) then
             call read_menu(option)
         end if
      end do

      return
200   format('Enter Distortion Magnification Factor')
300   format(A, I8)
400   format(A, E14.5)
150   format(//,'You have selected the following variable(s):')
160   format(i2,' = ',1a56)
      end

*-----------------------------------------------------------------------
      subroutine display_contour_id(numcont)
*-----------------------------------------------------------------------

      use posttypes
      use glob_vars

      include 'pubfunc.h'

      integer numcont

      real CONT_SEP_FACY

      parameter (CONT_SEP_FACY = 1.3)

      real CONT_ID_MARGINY_SUP, CONT_ID_MARGINY_INF

      parameter (CONT_ID_MARGINY_SUP = 0.15,
     +           CONT_ID_MARGINY_INF = 0.05)

      integer i

      real xfrac, yfrac
      real xwidth, xheight
      real dx
      real posy

      character cont_id_str*(MAXSTRINGLENGTH)
      character val_str*(MAXSTRINGLENGTH)

      call hf_open_segment('?Picture/info/cont_id')
      call hf_set_window(INFO_MARGINX_FRAC * 2.0 - 1.0, 
     +                   1.0 - INFO_MARGINX_FRAC * 2.0,
     +                   CONT_ID_MARGINY_INF * 2.0 - 1.0,
     +                   1.0 - CONT_ID_MARGINY_SUP * 2.0)

      call hf_set_camera_projection('stretched')
      call hf_set_text_font('size= 0.012 sru')
      call hf_set_text_alignment('<v')
                   
      call hf_set_window_frame('Off')

      call hf_compute_text_extent('.', 'X', xwidth, xheight)

      posy = 1.0

      call hf_open_segment('title')
      
      call hf_set_text_alignment('*')

      call hf_compute_text_extent('.', 'Contour Identification', 
     +                            xfrac, yfrac)

      yfrac = (yfrac - 0.5 * xheight) * 2.0 * CONT_SEP_FACY
         
      call hf_insert_text(0.0, posy - yfrac/2.0, 0.0,
     +                    'Contour Identification')
      
      call hf_close_segment()

      posy = posy - 2 * yfrac

      i = 1

      do while (i .le. numcont)
         if (conttype .eq. 'a') then
             write(val_str, fmt = var_fmt(itraknum(1))) autcontval(i)
         else
             write(val_str, fmt = var_fmt(itraknum(1))) mancontval(i)
         end if

         call ltrim(val_str)

         if (contlabl .eq. 'y') then
             write(cont_id_str, 100) charlabl(i)
             call hf_compute_text_extent('.', 
     +                                   cont_id_str(1:
     +                                   strlen(cont_id_str)),
     +                                   xfrac, yfrac)

             yfrac = (yfrac - 0.5 * xheight) * 2.0 * CONT_SEP_FACY
         
             call hf_insert_text(-1.0, posy - yfrac, 0.0, 
     +                           cont_id_str(1:strlen(cont_id_str)))

             dx = xwidth * 5
         else
             dx = 0.0
             call hf_compute_text_extent('.', 
     +                                   cont_id_str(1:
     +                                   strlen(val_str)),
     +                                   xfrac, yfrac)

             yfrac = (yfrac - 0.5 * xheight) * 2.0 * CONT_SEP_FACY
         end if

         call hf_insert_text(-1.0 + dx, posy - yfrac, 0.0,
     +                       val_str(1:strlen(val_str)))

         call hf_update_display()

         posy = posy - yfrac
         i = i + 1
      end do
       
      call hf_close_segment()

      return
100   format('(', a1, ')')
      end

*-----------------------------------------------------------------------
      subroutine save_contour_data(hcopyfname, numcont)
*-----------------------------------------------------------------------

      use posttypes
      use glob_vars

      include 'pubfunc.h'

      character hcopyfname*(MAXSTRINGLENGTH)
      integer   numcont

      character fname*(MAXSTRINGLENGTH)

      logical err

      err = .TRUE.

      fname = hcopyfname(1:strlen(hcopyfname)) // CONTDATAFILEEXT

      open(unit = CONTDATAUNIT, file = fname, status = 'unknown',
     +     err = 50)
          
      err = .FALSE.

      write(iout, *)
      write(iout, *) 'Contour data saved in file ' // fname

      if (conttype .eq. 'a') then
          call write_contdata(CONTDATAUNIT, contlabl, charlabl, 
     +                        numcont, autcontval)
      else
          call write_contdata(CONTDATAUNIT, contlabl, charlabl, 
     +                        numcont, mancontval)
      end if

      close(CONTDATAUNIT)

50    if (err) then
          call reperror(23, iout)
      end if

      return
      end

*-----------------------------------------------------------------------
      subroutine write_contdata(nunit, contlabl, charlabl, numcont,
     +                          contval)
*-----------------------------------------------------------------------

      include 'postconst.h'

      integer nunit
      character contlabl*1
      character charlabl(MAXCONTOURS)*1
      integer numcont
      double precision contval(MAXCONTOURS)

      integer i

      i = 1

      do while (i .le. numcont)
         if (contlabl .eq. 'y') then
             write(nunit, 100) i, charlabl(i), contval(i)
         else
             write(nunit, 200) i, contval(i)
         end if

         i = i + 1
      end do

      return
100   format('Contour ', i3, ' (label ', a1, ') at ', f14.5)
200   format('Contour ', i3, ' at ', F14.5)
      end

*-----------------------------------------------------------------------
      subroutine update_conplot(displaced, plot_mold_wall,
     +                          nummancont, numautcont)
*-----------------------------------------------------------------------

      use posttypes
      use glob_vars

      include 'pubfunc.h'

      logical displaced
      logical plot_mold_wall
      integer nummancont
      integer numautcont

      integer numcont
      double precision xminwall, yminwall
      double precision value

      call conlabl2(autcontval,mancontval,numautcont,
     +              nummancont,tmax,tmin,imax,imin,nn,
     +              icont, iout,contlabl, charlabl,
     +              conttype)
 

      if (conttype .eq. 'a') then
          numcont = numautcont
      else
          numcont = nummancont
      end if

      if (displaced) then
          do 200 i = 1, nn
             xdist(i) = x(i) + defmag * ut(i)
             ydist(i) = y(i) + defmag * vt(i)
200       continue
      end if

c  Determine largest and smallest x and y values in mesh
      call minmax(xdist,nnodes,xmin,xmax)
      call minmax(ydist,nnodes,ymin,ymax)

      if (plot_mold_wall) then
          call mincoord_mold_wall(zpos, defmag, xminwall,
     +                            yminwall)

          if (xminwall .lt. xmin) then
              xmin = xminwall
          end if

          if (yminwall .lt. ymin) then
              ymin = yminwall
          end if
      end if
     
      write(iout, *)

c-----------------------------------------------------------------------
c        Initialize terminal

       call hf_flush_contents('?Picture/plot...', 'geometry')
       call hf_flush_contents('?Picture/plot/annots...', 'text, lines')

       call setup_window(xwmin,ywmin,xwmax,ywmax)
       call hf_open_segment('?Picture/plot')

c----------------Plot nodes and nodes numbers if requested--------------
       if (nodplot .eq. 'y') call plotn(xdist,ydist,xwmin, ywmin,
     +                                  xwmax, ywmax, nn,nodnum)
c
c----------------Draw elements if requested-----------------------------
       if (elplot .eq. 'y') 
     +     call eplot(xdist,ydist,nn,nel,node,intrash)
c
c----------------Draw boundary if requested-----------------------------
       if (boundplt .eq. 'y') 
     +     call border(xdist,ydist,nn,nbe,nbnc,idash)
c
c-----------------------------------------------------------------------
c        Plot max and min labels on plot if desired
         if (contlabl .eq. 'y') 
     +       call labmm(sngl(xdist(imin)),sngl(ydist(imin)),
     +                  sngl(xdist(imax)),sngl(ydist(imax)),
     +                  xwmin, ywmin, xwmax, ywmax)
c-----------------------------------------------------------------------
         call hf_open_segment('?Picture/plot/contours')
         call hf_set_color('lines = orange yellow, 
     +                      text = white')
         call hf_set_text_alignment('<v')
         call hf_set_text_font('size= 0.015 sru, 
     +                          rotation= follow path')

         do 140 i=1,numcont
            if (conttype .eq. 'a') then
                value = autcontval(i)
            else if (conttype .eq. 'v') then
                     value = mancontval(i)
            end if

            call contur(value,itraknum(1),nn,nel,node,tempvar,
     +                  xdist,ydist,xwmin, ywmin, xwmax,ywmax,
     +                  intlab,contlabl,numdecval,
     +                  charlabl(i))
140      continue
         call hf_close_segment()
c----------------Draw mold wall if requested----------------------------
         if (plot_mold_wall) then
             call plot_original_wall(defmag)
             call plot_cur_wall(zpos, defmag)
         end if
c-----------------------------------------------------------------------

         call display_annotations()

         call hf_close_segment()

         call clear_info_area()
         
         call display_plot_status(PLOTTYPE_CONPLOT)
         call display_contour_id(numcont)

         call update_display()

         return
300   format(A, I8)
400   format(A, E14.5)
         end
