c-----------------------------------------------------------------------
      subroutine crossplot
c-----------------------------------------------------------------------
* Plots the principal stress crosses at a given scale.
*
* Author: Rodrigo A. Marin
* Sate  : December 5 1992
c-----------------------------------------------------------------------

      use posttypes
      use glob_vars

      include 'pubfunc.h'

      character prompt*(MAXPROMPTLENGTH)
      character hcopyfname*(MAXSTRINGLENGTH)

      double precision scale
      double precision smax

      integer i
      integer j
      integer m
      integer option

      logical quit1
      logical quit2
      logical ok
      logical scale_drawn

      integer invalid(1)
      integer defvar(1)
      real ref_pt(2)

      numvar = 1
      itraknum(1) = 4
      defvar(1) = 4
      invalid(1) = 38

      scale_drawn = .FALSE.
      scale = CROSSPLOT_DEFSCALE
      m = 0

      scale_posx = 0.0 
      scale_posy = 0.9
      write(*,*)'check these',iunit,iout
      
      if (.not. sol_file_open) then
          call open_solution_file(ibin, iunit, iout)
      end if

      write(iout, *)
      write(iout, *) 'Please use the graphics window'
      write(iout, *)

      call clear_messages()
        
      call find_iteration(timetype,time,newtime,
     +                    lastzpos,newzpos,casvel,
     +                    lastitnum,newitnum,
     +                    t,ut,vt,sigma,epsln,evp,seff,
     +                    epefft,eeff,epdot,uts,ratio,
     +                    e0,fa,tle,elastic,eflow,dmgcrt,emod,
     +                    ctime,nn,nns,itnum,
     +                    zpos, ibin,iout)

      timetype = 't'

c-----------------------------------------------------------------------
c        Assign tempvar to desired plot variable
      call assign (tempvar,t,ut,vt,sigma,epsln,evp,
     +             prst2,seff,epefft,eeff,epdot,uts,
     +             ratio,e0,fa,tle,elastic,eflow,dmgcrt,
     +             emod,ctime,nn,nns,
     +             itraknum)
c-----------------------------------------------------------------------

      call prst(sigma,sigma2,nns,intrash)

      i = 1

      do while (i .le. nns)
         varvals(16,i)=sigma2(1,i)
         varvals(17,i)=sigma2(2,i)
         varvals(18,i)=sigma2(3,i)
         varvals(19,i)=sigma2(4,i)

         i = i + 1
      end do

      call find_max_stress(m, smax)

c  Determine largest and smallest x and y values in mesh
      call minmax(x,nnodes,xmin,xmax)
      call minmax(y,nnodes,ymin,ymax)

      quit1 = .FALSE.
      curstate = STATE_CROSSPLOT_00
      newmenu = 12

      ref_pt(1) = -1.0
      ref_pt(2) = 1.0

      call set_menu(newmenu, ref_pt)
      call read_menu(option)

      do while (.not. quit1)
         if (curstate .eq. STATE_CROSSPLOT_00) then
             if (option .eq. 1) then
                 curstate = STATE_CROSSPLOT_01

                 ref_pt(1) = -1.0
                 ref_pt(2) = 1.0

                 newmenu = 2
             else if (option .eq. 2) then
                      curstate = STATE_CROSSPLOT_02

                      ref_pt(1) = MENUBAR_OPT_WIDTH_FRAC * (option - 1)
     +                            - 1.0
                      ref_pt(2) = 1.0

                      newmenu = 3
             else if (option .eq. 3) then
                  call read_variables(1, 1, invalid, 1, defvar,
     +                                numvar, itraknum)

c-----------------------------------------------------------------------
c        Assign tempvar to desired plot variable
                  call assign (tempvar,t,ut,vt,sigma,epsln,evp,
     +                         prst2,seff,epefft,eeff,epdot,uts,
     +                         ratio,e0,fa,tle,elastic,eflow,
     +                         dmgcrt,emod,ctime,nn,nns,
     +                         itraknum)
c-----------------------------------------------------------------------

                  call prst(sigma,sigma2,nns,intrash)

                  i = 1

                  do while (i .le. nns)
                     varvals(16,i)=sigma2(1,i)
                     varvals(17,i)=sigma2(2,i)
                     varvals(18,i)=sigma2(3,i)
                     varvals(19,i)=sigma2(4,i)

                     i = i + 1
                  end do

                  call find_max_stress(m, smax)

                  curstate = STATE_CROSSPLOT_00
                  newmenu = 12 

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0
             else if (option .eq. 4) then
                  call annotate_plot()
                  curstate = STATE_CROSSPLOT_00

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0

                  newmenu = 12
             else if (option .eq. 5) then
                  curstate = STATE_CROSSPLOT_03

                  ref_pt(1) = MENUBAR_OPT_WIDTH_FRAC * (option - 1)
     +                        - 1.0
                  ref_pt(2) = 1.0

                  newmenu = 7
             else if (option .eq. 6) then
                  curstate = STATE_CROSSPLOT_04

                  ref_pt(1) = MENUBAR_OPT_WIDTH_FRAC * (option - 1)
     +                        - 1.0
                  ref_pt(2) = 1.0

                  newmenu = 5
             end if
         else if (curstate .eq. STATE_CROSSPLOT_01) then
                  if (option .eq. 7) then         
                      write(prompt, 200)

                      scale = read_double(READ_DEFPOSX,
     +                                     READ_DEFPOSY,
     +                                     prompt, strlen(prompt),
     +                                     .TRUE., .FALSE., scale,
     +                                     '(F8.3)', ' ')
                  else if (option .eq. 8) then
                           write(prompt, 250)

                           ok = .FALSE.

                           do while (.not. ok)
                              m = read_integer(READ_DEFPOSX,
     +                                         READ_DEFPOSY,
     +                                         prompt, strlen(prompt), 
     +                                         .TRUE., .FALSE., m,
     +                                         ' ')

                              if ((m .lt. 0) .or. 
     +                            (m .gt. nhbw - 1)) then
                                  call rep_error(14)
                              else
                                  ok = .TRUE.
                                  call clear_errmsg()
                              end if
                           end do
                  else if (option .eq. 9) then
                           call read_scale_position(scale_posx, 
     +                                              scale_posy, 
     +                                              scale_drawn,
     +                                              xwmin, xwmax,
     +                                              ywmin, ywmax)
                  end if

                  curstate = STATE_CROSSPLOT_00
                  newmenu = 12

                  ref_pt(1) = -1.0
                  ref_pt(1) = 1.0
         else if (curstate .eq. STATE_CROSSPLOT_02) then
                  if (option .ne. MENU_NO_OPT_SEL) then
                      call ask_iter(option, time, newtime, lastzpos,
     +                              newzpos, casvel, lastitnum,
     +                              newitnum,iunit, iout, ibin,
     +                              timetype)

                      if (option .ne. 4) then
                          call find_iteration(timetype,time,newtime,
     +                                        lastzpos,newzpos,casvel,
     +                                        lastitnum,newitnum,
     +                                        t,ut,vt,sigma,epsln,evp,
     +                                        seff,epefft,eeff,epdot,
     +                                        uts,ratio,e0,fa,tle,
     +                                        elastic,eflow,dmgcrt,emod,
     +                                        ctime,nn,nns,itnum,zpos,
     +                                        ibin, iout)

                          write(iout, *)
                          write(iout, *)
     +                    'Plot will be done for the following data:'
                          write(iout, *)
                          write(iout, 300)'Iteration : ', itnum
                          write(iout, 400)'Time      : ', ctime
                          write(iout, 400)'Z-position: ', zpos

c-----------------------------------------------------------------------
c        Assign tempvar to desired plot variable
                          call assign (tempvar,t,ut,vt,sigma,epsln,evp,
     +                                 prst2,seff,epefft,eeff,epdot,uts,
     +                                 ratio,e0,fa,tle,elastic,eflow,
     +                                 dmgcrt,emod,ctime,nn,nns,
     +                                 itraknum)
c-----------------------------------------------------------------------

                          call prst(sigma,sigma2,nns,intrash)

                          i = 1

                          do while (i .le. nns)
                             varvals(16,i)=sigma2(1,i)
                             varvals(17,i)=sigma2(2,i)
                             varvals(18,i)=sigma2(3,i)
                             varvals(19,i)=sigma2(4,i)

                             i = i + 1
                          end do
                      end if
                  end if

                  curstate = STATE_CROSSPLOT_00
                  newmenu = 12

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0
         else if (curstate .eq. STATE_CROSSPLOT_03) then
                  curstate = STATE_CROSSPLOT_00
                  newmenu = 12 

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0

                  if (option .eq. 1) then
                      call update_crossplot(scale, m, smax)
                      call draw_scale(scale,xwmin,ywmin,xwmax, ywmax, 
     +                                smax,scale_posx, scale_posy,
     +                                '?Picture/plot/crosses',
     +                                'MPa')

                      scale_drawn = .TRUE.
                  else if (option .eq. 2) then
                           call clear_plot_area()
                           call clear_info_area()
                  else if (option .eq. 3) then
                           call generate_hardcopy(iunit, iout,
     +                                            hcopyfname)
                  else if (option .eq. 4) then
                           call generate_pict_file(iunit, iout,
     +                                             hcopyfname)
                  else if (option .eq. 5) then
                           quit1 = .TRUE.
                           curstate =  STATE_NONGRAPH
                           newmenu = MENU_NO_MENU
                  end if
         else if (curstate .eq. STATE_CROSSPLOT_04) then
                  if (option .ne. MENU_NO_OPT_SEL) then
                      call window_definition(option)

                      if (scale_drawn) then
                          call draw_scale(scale,xwmin,ywmin,xwmax,
     +                                    ywmax, smax,scale_posx,
     +                                    scale_posy,
     +                                    '?Picture/plot/crosses',
     +                                    'MPa')
                      end if
                  end if

                  curstate = STATE_CROSSPLOT_00
                  newmenu = 12 

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0
         end if

         call set_menu(newmenu, ref_pt)

         if (newmenu .ne. MENU_NO_MENU) then
             call read_menu(option)
         end if

      end do

      return
200   format('Enter Scale Factor in Stress Units')
250   format('How many Nodes to skip between crosses?')
300   format(A, I8)
400   format(A, E14.5)
      end

c-----------------------------------------------------------------------
      subroutine cross(scale,st,sc,theta,x,y)
c-----------------------------------------------------------------------

      include 'postconst.h'
      include 'pubfunc.h'

      double precision scale, st, sc, theta, x, y
      double precision smag, dx, dy, xi, yi, xf, yf
      double precision dxt, dyt, xit, yit, xft, yft
      double precision s(2)

      integer i

      s(1)=st
      s(2)=sc
      do 100 i=1,2
         smag = dabs(s(i)*scale/2.0)
         if (i.eq.2) go to 10
            dx = smag*dcosd(theta)
            dy = smag*dsind(theta)
            go to 20
10          dx = -smag*dsind(theta)
            dy = smag*dcosd(theta)

20          xi = x - dx
            yi = y - dy
            xf = x + dx
            yf = y + dy

            if (s(i).lt.0.0) go to 30
c
c   Tension mark
c
         call line(xi, yi, xf, yf)
         go to 100
c
c    Compression mark with tics
c
30       dxt = -dy / 3.0
         dyt = dx / 3.0

         xit = xi - dxt
         yit = yi - dyt
         xft = xi + dxt
         yft = yi + dyt
         call line(xit, yit, xi, yi)
         call line(xft, yft, xi, yi)
         call line(xi, yi, xf, yf)
         xit = xf - dxt
         yit = yf - dyt
         xft = xf + dxt
         yft = yf + dyt
         call line(xit, yit, xf, yf)
         call line(xft, yft, xf, yf)
100   continue
      return
      end

c-----------------------------------------------------------------------
      subroutine find_max_stress(skip, smax)
c-----------------------------------------------------------------------

      use posttypes
      use glob_vars

      integer skip
      double precision smax
    
      integer i, j

      do while (i .le. nn)
         j = 0

         do while ((j .lt. nhbw - 1) .and. (i + j .le. nn))
            st = varvals(16, i + j)
            sc = varvals(17, i + j)

            theta = varvals(19, i + j)

            if (dabs(st) .gt. smax) then
                smax = dabs(st)
            end if

            if (dabs(sc) .gt. smax) then
                smax = dabs(sc)
            end if

            j = j + skip + 1
         end do
         i = i + (skip + 1) * (nhbw - 1)
      end do

      return
      end

c-----------------------------------------------------------------------
      subroutine update_crossplot(scale, m, smax)
c-----------------------------------------------------------------------


      use posttypes
      use glob_vars

      include 'pubfunc.h'

      integer i
      integer j
      integer m

      logical scale_drawn

      double precision scale
      double precision smax
      double precision xc
      double precision yc
c-----------------------------------------------------------------------
c           Initialize terminal

      call hf_flush_contents('?Picture/plot...', 'geometry')
      call hf_flush_contents('?Picture/plot/annots...', 'text, lines')

      call setup_window(xwmin,ywmin,xwmax,ywmax)
      call hf_open_segment('?Picture/plot')

      yw = ywmax - ywmin

      i = 1
      smax = varvals(16, 1)

      call hf_open_segment('?Picture/plot/crosses')
      call hf_set_color('lines = yellow green')

      do while (i .le. nn)
         j = 0

         do while ((j .lt. nhbw - 1) .and. (i + j .le. nn))
            st = varvals(16, i + j)
            sc = varvals(17, i + j)

            theta = varvals(19, i + j)

            if (dabs(st) .gt. smax) then
                smax = dabs(st)
            end if

            if (dabs(sc) .gt. smax) then
                smax = dabs(sc)
            end if

            xc = x(i + j)
            yc = y(i + j)

            call cross(scale, st, sc, theta, xc, yc, maxstress_inwin)

            j = j + m + 1
         end do
         i = i + (m + 1) * (nhbw - 1)
      end do

      call hf_close_segment()

      call border(x,y,nn,nbe,nbnc,0)

      call display_annotations()

      call hf_close_segment()

      call clear_info_area()

      call display_plot_status(PLOTTYPE_CROSSPLOT)

      call update_display()

      return
      end
