*-----------------------------------------------------------------
      subroutine dashline(xi, yi, xf, yf)
*-----------------------------------------------------------------
*     Plots a dashed line between the specified points. This function
*     is intended to replace the dashed line capability of the 
*     Plot10 library, which doesn't work.
*
*     Author: Rodrigo A. Marin
*     Date  : January 30 1993
*-----------------------------------------------------------------

      include 'postcom.f'
      include 'pubfunc.h'

      double precision DASHLINE_WFAC

      parameter (DASHLINE_WFAC = 1.0/90.0)
c     Dash length is 1/90 times the length of the window diagonal.
      
      double precision DASHLINE_SPFAC

      parameter (DASHLINE_SPFAC = 1.0/3.0)

c     Space between dashes is one third of the dash length.

      double precision xi, yi
      double precision xf, yf

      double precision x1, y1
      double precision x2, y2

      double precision alpha
      double precision dalpha
      double precision l
      double precision ls

      l = dsqrt((xf - xi)**2 + (yf - yi)**2)

      ls = length_win_diag * DASHLINE_WFAC

      dalpha = ls / l

      alpha = 0.0
      x1 = xi
      y1 = yi

      do while (alpha .lt. 1.0)
         alpha = alpha + dalpha

         if (alpha .gt. 1.0) then
             alpha = 1.0
         end if
 
         x2 = xi + alpha * (xf - xi)
         y2 = yi + alpha * (yf - yi)

         call line(x1, y1, x2, y2)

         alpha = alpha + dalpha * DASHLINE_SPFAC

         x1 = xi + alpha * (xf - xi)
         y1 = yi + alpha * (yf - yi)
      end do

      return
      end
