*---------------------------------------------------------------------
      subroutine border(x, y, nn, nbe, nbnc, idash)
*---------------------------------------------------------------------

      integer nn
      double precision x(nn), y(nn)
      integer nbe, nbnc(5, nbe)


      real xs1, ys1, xs2, ys2

      i = 1

      do while (i .le. nbe)
         xs1 = x(nbnc(1, i))
         ys1 = y(nbnc(1, i))
         xs2 = x(nbnc(2, i))
         ys2 = y(nbnc(2, i))

         call hf_insert_line(xs1, ys1, 0.0, xs2, ys2, 0.0)
         i = i + 1
      end do

      return
      end

*---------------------------------------------------------------------
      subroutine clear_annot_type()
*---------------------------------------------------------------------

      call hf_flush_contents('?Picture/info/plot_status/annot_type',
     +                       'text')

      return
      end

*---------------------------------------------------------------------
      subroutine clear_plot_area
*---------------------------------------------------------------------

      include 'postconst.h'
      include 'pubfunc.h'

      call hf_flush_contents('?Picture/plot...', 'geometry')
      call hf_flush_contents('?Picture/plot/annots...', 'text, lines')

      return
      end

*---------------------------------------------------------------------
      subroutine display_annotations
*---------------------------------------------------------------------

      use posttypes
      use glob_vars

      include 'pubfunc.h'

      integer i

      character segname*(MAXSTRINGLENGTH)

      if (numannot .gt. 0) then
          call hf_open_segment('?Picture/plot/annots')

          i = 1

          do while (i .le. MAXNUMANNOT)
             if (.not. annotation_tbl(i)%available) then
                 if (annotation_tbl(i)%ent_type .eq. 
     +               ENTTYPE_TEXT) then
                     write(segname, 100) i
                     call hf_open_segment('text')
                 else
                     write(segname, 200) i
                     call hf_open_segment('lines')
                 end if

                 call hf_open_segment(segname(1:strlen(segname)))

                 if (annotation_tbl(i)%ent_type .eq. 
     +               ENTTYPE_TEXT) then
                     call hf_set_text_font('size = 0.015 sru')
                     call hf_set_text_alignment('<v')

                     call hf_insert_text(annotation_tbl(i)%posx, 
     +                                   annotation_tbl(i)%posy, 0.0, 
     +                                   annotation_tbl(i)%str(1:
     +                                   strlen(annotation_tbl(i)%str)))
                 else
                     call hf_insert_line(annotation_tbl(i)%posx1,
     +                                   annotation_tbl(i)%posy1, 0.0,
     +                                   annotation_tbl(i)%posx2,
     +                                   annotation_tbl(i)%posy2, 0.0)
                 end if

                 call hf_close_segment()
                 call hf_close_segment()
             end if

             i = i + 1
          end do

          call hf_close_segment()
      end if

      return
100   format('annotation text', I3)
200   format('annotation line', I3)
      end

*---------------------------------------------------------------------
      subroutine display_menu(menuspec, ref_pt)
*---------------------------------------------------------------------

      use posttypes

      include 'postconst.h'
      include 'pubfunc.h'

      type (menu_spec) menuspec
      real   ref_pt(2)

      integer   i
      character str*(MAXSTRINGLENGTH) 

      real    total_width
      real    total_height
      real    option_height
      real    xfrac, yfrac
      real    posx, posy
       
      if (menuspec%level .eq. 0) then
          call hf_flush_contents('?Picture/menu_bar', 'segment')
          call hf_open_segment('?Picture/menu_bar')
      else
          call hf_open_segment('?Picture/menu')
      end if

      call hf_compute_text_extent('.', 
     +                            menuspec%labels(1)(1:
     +                            strlen(menuspec%labels(1))),
     +                            xfrac, yfrac)

      total_width = xfrac * 2.0
      option_height = yfrac * 2.0
      total_height = option_height

      i = 2

      do while (i .le. menuspec%numopt)
         call hf_compute_text_extent('.', 
     +                               menuspec%labels(i)(1:
     +                               strlen(menuspec%labels(i))),
     +                               xfrac, yfrac)

         if (2.0 * xfrac .gt. total_width) then
             total_width = xfrac * 2.0
         end if

         total_height = total_height + yfrac * 2.0

         i = i + 1
      end do

      call hf_open_segment(menuspec%name(1:strlen(menuspec%name)))
      call hf_set_selectability('windows = off')

      if (menuspec%level .eq. 0) then
          menuspec%extents(1) = -1.0
          menuspec%extents(2) = -1.0
          menuspec%extents(3) = 1.0
          menuspec%extents(4) = 1.0
      else
          menuspec%extents(1) = ref_pt(1)
          menuspec%extents(2) = ref_pt(2) - total_height
          menuspec%extents(3) = ref_pt(1) + total_width
          menuspec%extents(4) = ref_pt(2)
      end if

      i = 1
      posy = ref_pt(2)

      do while (i .le. menuspec%numopt)
         write(str, 100) i
         call ltrim(str)

         call hf_compute_text_extent('.',
     +                               menuspec%labels(i)(1:
     +                               strlen(menuspec%labels(i))),
     +                               xfrac, yfrac)

         option_height = yfrac * 2.0
         option_width = xfrac * 2.0

         call hf_open_segment(str)
 
         if (menuspec%active(i)) then
             call hf_set_color('text = ' // ACTIVE_OPTION_COLOR)
         else
             call hf_set_color('text = ' // NONACTIVE_OPTION_COLOR)
         end if

         if (menuspec%level .eq. 0) then
             posx = (i - 1) * MENUBAR_OPT_WIDTH_FRAC - 1.0
             posy = -1.0

             call hf_set_window(posx, posx + option_width, posy,
     +                          posy + option_height)
             call hf_set_camera_projection('stretched')

             call hf_insert_text(-1.0, -1.0, 0.0, menuspec%labels(i)(1:
     +                           strlen(menuspec%labels(i))))
         else
             posx = ref_pt(1)
             posy = posy - option_height

             call hf_set_window(posx, posx + total_width, posy,
     +                          posy + option_height)

             call hf_set_window_pattern('solid')
             call hf_set_camera_by_volume('Orthographic',
     +                                    -1.0, 1.0, -1.0, 1.0)
             call hf_set_camera_projection('stretched')

             call hf_insert_text(-1.0, -1.0, 0.0, menuspec%labels(i)(1:
     +                           strlen(menuspec%labels(i)))) 

         end if

         if (menuspec%active(i)) then
             call hf_set_selectability('v*o^')
         end if

         call hf_close_segment()

         i = i + 1
      end do

      call hf_close_segment()
      call hf_close_segment()

      return
100   format(I2)
      end

*---------------------------------------------------------------------
      subroutine dashline(xi, yi, xf, yf)
*---------------------------------------------------------------------

      include 'postconst.h'
      include 'pubfunc.h'

      double precision xi, yi
      double precision xf, yf

      real x1, y1
      real x2, y2

      character pattern*(MAXSTRINGLENGTH)

      call hf_set_line_pattern('- -')

      x1 = xi
      y1 = yi
      x2 = xf
      y2 = yf

      call hf_insert_line(x1, y1, 0.0, x2, y2, 0.0)

      return
      end

*---------------------------------------------------------------------
      subroutine display_annot_type(ent_type)
*---------------------------------------------------------------------

      include 'postconst.h'
      include 'pubfunc.h'

      integer ent_type

      real xfrac, yfrac
      real xwidth, xheight
      real posy

      character str*(MAXSTRINGLENGTH)

      call clear_annot_type()

      call hf_open_segment('?Picture/info/plot_status')
      call hf_open_segment('annot_type')

      call hf_compute_text_extent('.', 'X', xwidth, xheight)

      yfrac = xheight * STATUS_SEP_FACY
      
      posy = 1.0 - 8.0 * yfrac

      if (ent_type .eq. ENTTYPE_TEXT) then
          str = 'Annotation Type: Text'
      else if (ent_type .eq. ENTTYPE_LINE) then
          str = 'Annotation Type: Line'
      end if

      call hf_insert_text(-1.0, posy, 0.0, str(1:strlen(str)))
      call update_display()

      call hf_close_segment()
      call hf_close_segment()

      return
      end

*---------------------------------------------------------------------
      subroutine display_plot_status(plot_type)
*---------------------------------------------------------------------

      use posttypes
      use glob_vars

      include 'pubfunc.h'

      integer plot_type

      real xfrac, yfrac
      real xwidth, xheight
      real posy

      character str*(MAXSTRINGLENGTH)
 
      integer i

      call hf_open_segment('?Picture/info/plot_status')

      call hf_compute_text_extent('.', 'X', xwidth, xheight)

      posy = 1.0

      call hf_open_segment('title')

      call hf_set_text_alignment('*')

      if (plot_type .eq. PLOTTYPE_CONPLOT) then
          str = 'CONTOUR PLOT'
      else if (plot_type .eq. PLOTTYPE_DISPLOT) then
               str = 'DISPLACED SHAPE PLOT'
      else if (plot_type .eq. PLOTTYPE_CROSSPLOT) then
               str = 'STRESS CROSSES PLOT'
      else if (plot_type .eq. PLOTTYPE_MESHPLOT) then
               str = 'MESH PLOT'
      end if

      call hf_compute_text_extent('.', str, xfrac, yfrac)

      yfrac = (yfrac - 0.5 * xheight) * 2.0 * STATUS_SEP_FACY 

      call hf_insert_text(0.0, posy - yfrac/2.0, 0.0, 
     +                    str(1:strlen(str)))

      call hf_close_segment()

      posy = posy - yfrac

      call hf_open_segment('varname')

      call hf_set_text_alignment('*')

      call hf_compute_text_extent('.', header(itraknum(1))(1:
     +                                 strlen(header(itraknum(1)))),
     +                            xfrac, yfrac)
      
      yfrac = (yfrac - 0.5 * xheight) * 2.0 * STATUS_SEP_FACY

      call hf_insert_text(0.0, posy - yfrac/2.0, 0.0,
     +                    header(itraknum(1))(1:
     +                    strlen(header(itraknum(1)))))

      call hf_close_segment()

      posy = posy - 2.0 * yfrac

      i = 1

      do while (i .le. 3)
         if (i .eq. 1) then
             write(str, 100) ctime
         else if (i .eq. 2) then
             write(str, 200) zpos
         else if (i .eq. 3) then
             write(str, 300) itnum
         end if

         call hf_compute_text_extent('.', str(1:strlen(str)), xfrac,
     +                               yfrac)

         yfrac = (yfrac - 0.5 * xheight) * 2.0 * STATUS_SEP_FACY

         call hf_insert_text(-1.0, posy - yfrac, 0.0, str)

         posy = posy - yfrac 
         i = i + 1
      end do
      
      call hf_close_segment()

      return
100   format('t= ', E14.5)
200   format('z= ', E14.5)
300   format('Iteration: ', I8)
      end

*---------------------------------------------------------------------
      subroutine dottedline(xi, yi, xf, yf)
*---------------------------------------------------------------------

      include 'postconst.h'
      include 'pubfunc.h'

      double precision xi, yi
      double precision xf, yf

      real x1, y1
      real x2, y2

      character pattern*(MAXSTRINGLENGTH)

      call hf_set_line_pattern('....')

      x1 = xi
      y1 = yi
      x2 = xf
      y2 = yf

      call hf_insert_line(x1, y1, 0.0, x2, y2, 0.0)

      return
      end

*---------------------------------------------------------------------
      subroutine eplot(x, y, nn, numel, node, intrash)
*---------------------------------------------------------------------

      integer nn, numel
      integer node(3, numel)

      double precision x(nn), y(nn)

      real x1, x2, x3
      real y1, y2, y3

      integer i

      i = 1

      do while (i .le. numel)
         x1 = x(node(1, i))
         x2 = x(node(2, i))
         x3 = x(node(3, i))
         y1 = y(node(1, i))
         y2 = y(node(2, i))
         y3 = y(node(3, i))

         call hf_insert_line(x1, y1, 0.0, x2, y2, 0.0)
         call hf_insert_line(x2, y2, 0.0, x3, y3, 0.0)
         call hf_insert_line(x3, y3, 0.0, x1, y1, 0.0)

         i = i + 1
      end do

      return
      end

*---------------------------------------------------------------------
      subroutine init_graphics(xmin, ymin, xmax, ymax)
*---------------------------------------------------------------------

      include 'postconst.h'

      double precision xmin, ymin, xmax, ymax

      real MENUWIN_MINX, MENUWIN_MAXX
      real MENUWIN_MINY, MENUWIN_MAXY
      real PLOTWIN_MINX, PLOTWIN_MAXX
      real PLOTWIN_MINY, PLOTWIN_MAXY
      real INFOWIN_MINX, INFOWIN_MAXX
      real INFOWIN_MINY, INFOWIN_MAXY
      real MSGWIN_MINX,  MSGWIN_MAXX
      real MSGWIN_MINY,  MSGWIN_MAXY

      parameter(PLOTWIN_MINX = -1.0, PLOTWIN_MAXX = 2.0/3.0,
     +          PLOTWIN_MINY = -9.0/10.0, PLOTWIN_MAXY = 9.0/10.0)
                
      parameter(MENUWIN_MINX = -1.0, MENUWIN_MAXX = 2.0/3.0,
     +          MENUWIN_MINY = 9.0/10.0, MENUWIN_MAXY = 1.0)

      parameter (MSGWIN_MINX = -1.0, MSGWIN_MAXX = 2.0/3.0,
     +           MSGWIN_MINY = -1.0, MSGWIN_MAXY = -9.0/10.0)

      parameter(INFOWIN_MINX = 2.0/3.0, INFOWIN_MAXX = 1.0,
     +          INFOWIN_MINY = -1.0,    INFOWIN_MAXY = 1.0)

      call hf_open_segment('?Picture')
      call hf_set_window_frame('On')
      call hf_set_color('window contrast = white')
      call hf_set_color('window = black, lines = white, markers = white,
     +                   text = white')

      call hf_open_segment('plot')

      call hf_set_window(PLOTWIN_MINX, PLOTWIN_MAXX, PLOTWIN_MINY,
     +                   PLOTWIN_MAXY)
      call hf_set_text_font('size= 0.02 sru')
      call hf_set_text_alignment('<v')
      call setup_window(xmin, ymin, xmax, ymax)
      call hf_create_segment('annots')
      call hf_qset_selectability('?Picture/plot/annots',
     +                           'windows = off')
      call hf_create_segment('annots/text')
      call hf_qset_text_font('?Picture/plot/annots/text',
     +                       'size = 0.015 sru')
      call hf_qset_text_alignment('?Picture/plot/annots/text',
     +                            '<v')
      call hf_create_segment('annots/lines')
      call hf_create_segment('crosses')
      call hf_qset_selectability('?Picture/plot/crosses',
     +                           'windows = off')
      call hf_create_segment('cutplane')
      call hf_qset_color('?Picture/plot/cutplane',
     +                   'lines = yellow')
      call hf_qset_line_pattern('?Picture/plot/cutplane', '- -')

      call hf_close_segment()

      call hf_open_segment('menu')

      call hf_set_window(PLOTWIN_MINX, PLOTWIN_MAXX, PLOTWIN_MINY,
     +                    PLOTWIN_MAXY)
      call hf_set_text_font('size= 0.02 sru')
      call hf_set_text_alignment('<v')
      call hf_set_window_pattern('clear')
      call hf_set_selectability('windows = off')
      call hf_close_segment()

      call hf_open_segment('menu_bar')
      call hf_set_window(MENUWIN_MINX, MENUWIN_MAXX, MENUWIN_MINY,
     +                   MENUWIN_MAXY)
      call hf_set_text_font('size= 0.02 sru')
      call hf_set_text_alignment('<v')
      call hf_close_segment()

      call hf_open_segment('messages')
      call hf_set_window(MSGWIN_MINX, MSGWIN_MAXX, MSGWIN_MINY,
     +                   MSGWIN_MAXY)
      call hf_set_text_font('size= 0.015 sru')
      call hf_set_text_alignment('<v')
      call hf_set_camera_projection('stretched')
      call hf_close_segment()

      call hf_open_segment('info')
      call hf_set_window(INFOWIN_MINX, INFOWIN_MAXX, INFOWIN_MINY,
     +                   INFOWIN_MAXY)
      call hf_create_segment('plot_status')
      call hf_qset_window('?Picture/info/plot_status',
     +                   INFO_MARGINX_FRAC * 2.0 - 1.0,
     +                   1.0 - INFO_MARGINX_FRAC * 2.0,
     +                   PLOT_STATUS_MARGINY_INF * 2.0 - 1.0,
     +                   1.0 - PLOT_STATUS_MARGINY_SUP * 2.0)

      call hf_qset_camera_projection('?Picture/info/plot_status', 
     +                               'stretched')
      call hf_qset_text_font('?Picture/info/plot_status',
     +                       'size= 0.012 sru')
      call hf_qset_text_alignment('?Picture/info/plot_status',
     +                            '<v')
      call hf_qset_window_frame('?Picture/info/plot_status', 'Off')
      call hf_create_segment('plot_status/annot_type')
      call hf_close_segment()

      call hf_close_segment()

      call hf_update_display()

      return
      end

*---------------------------------------------------------------------
      subroutine labmm(xmin,ymin,xmax,ymax, xwmin, ywmin, xwmax, ywmax)
*---------------------------------------------------------------------

      real xmin,ymin,xmax,ymax
      double precision xwmin, ywmin, xwmax, ywmax
      character string1*3, string2*3

      string1='MIN'
      string2='MAX'

      call hf_open_segment('?Picture/plot/minmaxlab')
      call hf_set_text_font('size = 0.015 sru')

      call hf_insert_text(xmin, ymin, 0.0, string1)
      call hf_insert_text(xmax, ymax, 0.0, string2)

      call hf_close_segment()

      return
      end

*---------------------------------------------------------------------
      subroutine labplot(x1, y1, label)
*---------------------------------------------------------------------

      double precision x1, y1, x2, y2
      character label*(*)

      character blank*2

      real x, y

      blank = ' '
      blank = trim(adjustl(blank))

      call hf_open_segment(blank)

      call hf_set_text_font('size= 0.01 sru')
      call hf_set_text_alignment('<v')

      x = x1
      y = y1

      call hf_insert_text(x, y, 0.0, label)

      call hf_close_segment()

      return
      end

*---------------------------------------------------------------------
      subroutine draw_scale(scale, xmin, ymin, xmax, ymax, maxmag,
     +                      scale_posx, scale_posy, segment, units)
*---------------------------------------------------------------------

      include 'postconst.h'
      include 'pubfunc.h'

      logical hf_compute_coordinates

      double precision scale, xmin, ymin, xmax, ymax, maxmag
      real scale_posx, scale_posy
      character segment*(*)
      character units*(*)

      double precision dx,dyt
      double precision ll, rl

      real scale_poswin(3)
      real scale_posworld(3)

      double precision power

      logical err

      logical quit

      character string*(MAXSTRINGLENGTH)

      scale_poswin(1) = scale_posx
      scale_poswin(2) = scale_posy
      scale_poswin(3) = 0.0

      call hf_open_segment(segment)
      call hf_open_segment('scale')

      call hf_flush_contents('.', 'text, lines')

      err = hf_compute_coordinates(segment, 'local window', 
     +                             scale_poswin, 'camera', 
     +                             scale_posworld)

      if (dabs(maxmag) .le. ZERO) then
          rl = 1.0
          power = 0.0
      else
          power = log10(maxmag)
          power = dnint(power)

          if (power .eq. 0.0) then
              rl = 1.0
          else
              rl = 10.0 ** power
          end if
      end if
    
      quit = .FALSE.

      do while (.not. quit)
         if (scale_posworld(1) + rl * scale .lt. xmax) then
             quit = .TRUE.
         else
             power = power - 1.0
             rl = rl / 10.0
         end if
      end do
      
      dyt = min((ymax - ymin) / 30.0, rl * scale / 5.0)

      call hf_set_line_pattern('----')

      call hf_insert_line(scale_posworld(1),
     +                    sngl(scale_posworld(2) + dyt), 0.0,
     +                    scale_posworld(1),
     +                    sngl(scale_posworld(2) - dyt), 0.0)

      call hf_insert_line(scale_posworld(1), scale_posworld(2), 0.0,
     +                    sngl(scale_posworld(1) + rl * scale),
     +                    scale_posworld(2), 0.0)

      call hf_insert_line(sngl(scale_posworld(1) +  rl * scale),
     +                    sngl(scale_posworld(2) + dyt), 0.0,
     +                    sngl(scale_posworld(1) + rl * scale),
     +                    sngl(scale_posworld(2) - dyt), 0.0)

      write(string, 100) idnint(power)
      string = string(1:strlen(string)) // ' ' // units

      call hf_qset_text_font(segment, 'size = 0.015 sru')
      call hf_qset_text_alignment(segment, '<v')

      call hf_insert_text(sngl(scale_posworld(1) + dyt),
     +                    sngl(scale_posworld(2) + dyt), 0.0,
     +                    string)
      
      call hf_close_segment()
      call hf_close_segment()

      return
100   format('1.0  E', I3)
      end

*---------------------------------------------------------------------
      subroutine line(x1, y1, x2, y2)
*---------------------------------------------------------------------

      double precision x1, y1
      double precision x2, y2

      real xi, yi
      real xf, yf

      xi = x1
      yi = y1
      xf = x2
      yf = y2

      call hf_insert_line(xi, yi, 0.0, xf, yf, 0.0)

      return
      end

*---------------------------------------------------------------------
      subroutine plotn(x, y, xwmin, ywmin, xwmax, ywmax, nn, nodnum)
*---------------------------------------------------------------------

      include 'postconst.h'
      include 'pubfunc.h'

      integer nn

      double precision x(nn), y(nn)
      double precision xwmin, ywmin, xwmax, ywmax
      
      character nodnum*1
      character numstr * (MAXSTRINGLENGTH)

      integer i
      real xi, yi

      character marker_symbol*(MAXSTRINGLENGTH)

c     call hf_set_marker_symbol('.')
c     call hf_set_marker_size(sngl(0.1))

      if (nodnum .eq. 'y') then
          call hf_set_text_alignment('<v')
          call hf_set_text_font('size= 0.015 sru')
      end if

      i = 1

      do while (i .le. nn)
         xi = x(i)
         yi = y(i)

c        call hf_insert_marker(xi, yi, 0.0)    ## Problem with marker size when resizing window.

         call hf_insert_line(xi, yi, 0.0, xi, yi, 0.0)
         
         if (nodnum .eq. 'y') then
             write(numstr, 100) i
             call ltrim(numstr)
             call hf_insert_text(xi, yi, 0.0, numstr(1:strlen(numstr))) 
         end if
 
         i = i + 1
      end do  

      return
100   format (I4)
      end
 
*---------------------------------------------------------------------
      subroutine scalemark(scale_posx, scale_posy, xwmin, xwmax,
     +                     ywmin, ywmax)
*---------------------------------------------------------------------

      include 'postconst.h'
      include 'pubfunc.h'

      real scale_posx, scale_posy

      double precision xwmin, ywmin, xwmax, ywmax

      real scale_poswin(3)
      real scale_posworld(3)
      
      real posx
      real lmark

      character string*(MAXSTRINGLENGTH)

      logical err
      logical hf_compute_coordinates

      scale_poswin(1) = scale_posx
      scale_poswin(2) = scale_posy
      scale_poswin(3) = 0.0

      err= hf_compute_coordinates('?Picture/plot/crosses',
     +                            'local window', scale_poswin,
     +                            'camera', scale_posworld)

      call hf_qset_text_font('?Picture/plot/crosses',
     +                       'size = 0.015 sru')
      call hf_qset_text_alignment('?Picture/plot/crosses',
     +                            '<v')
      call hf_open_segment('?Picture/plot/crosses/scalemark')
      call hf_set_color('lines = yellow green')

      call hf_flush_contents('.', 'geometry')

      lmark = (xwmax - xwmin) / 15.0
 
      posx = scale_posworld(1) + lmark

      call hf_insert_line(scale_posworld(1), scale_posworld(2), 0.0,
     +                    posx, scale_posworld(2), 0.0)

      call hf_insert_line(scale_posworld(1), scale_posworld(2) - 
     +                    lmark/10.0, 0.0, scale_posworld(1), 
     +                    scale_posworld(2) + lmark/10.0, 0.0)
      
      call hf_insert_line(scale_posworld(1) + lmark, scale_posworld(2) - 
     +                    lmark/10.0, 0.0, scale_posworld(1) + lmark,
     +                    scale_posworld(2) + lmark/10.0, 0.0)
      
      call hf_insert_text(scale_posworld(1), scale_posworld(2) +
     +                    lmark / 10.0, 0.0, 'New Scale Pos.')

      call hf_close_segment()

      return
      end

*---------------------------------------------------------------------
      subroutine setup_window(xmin, ymin, xmax, ymax)
*---------------------------------------------------------------------

      double precision xmin, ymin, xmax, ymax
      real   xminr, yminr
      real   xmaxr, ymaxr

      real margin_x
      real margin_y

      margin_x = (xmax - xmin) * 0.1
      margin_y = (ymax - ymin) * 0.1

      xminr = xmin - margin_x
      yminr = ymin - margin_y
      xmaxr = xmax + margin_x
      ymaxr = ymax + margin_y

      call hf_qset_camera_by_volume('?Picture/plot', 'Orthographic', 
     +                              xminr, xmaxr, yminr, ymaxr)

      return
      end

*-----------------------------------------------------------------------
      subroutine show_cut_plane(x1, y1, x2, y2)
*-----------------------------------------------------------------------

      double precision x1, y1, x2, y2

      call hf_flush_contents('?Picture/plot/cutplane', 'lines')
      call hf_open_segment('?Picture/plot/cutplane')
      call dashline(x1, y1, x2, y2)
      call hf_close_segment()

      return
      end

*---------------------------------------------------------------------
      subroutine titlep(dx, dy, title)
*---------------------------------------------------------------------

      include 'postconst.h'

      double precision dx, dy

      character title*(MAXSTRINGLENGTH) 

      call hf_open_segment('?Picture/plot/plot_title')
      call hf_set_text_font('size = 0.015 sru')
      call hf_flush_contents('.', 'text')
      
      call hf_insert_text(sngl(dx), sngl(dy), 0.0, title)

      call hf_close_segment()

      return
      end

*---------------------------------------------------------------------
      subroutine update_display
*---------------------------------------------------------------------

      call hf_update_display()

      return
      end
