      subroutine meshplt
***************** Last revision  2/06/92 *******************************
*
*            Mesh plotting driver subroutine
*
************************************************************************
c23456789112345678921234567893123456789412345678951234567896123456789712
c

      use posttypes
      use glob_vars

      include 'pubfunc.h'

      integer option
      integer newmenu

      character prompt*(MAXPROMPTLENGTH)
      character hcopyfname*(MAXSTRINGLENGTH)

      real ref_pt(2)

      logical quit

      quit = .FALSE.

      write(iout, *)
      write(iout, *) 'Please use the graphics window'
      write(iout, *)

      call clear_messages()
        
c  Determine largest and smallest x and y values in mesh
      call minmax(x,nnodes,xmin,xmax)
      call minmax(y,nnodes,ymin,ymax)

c-----------------------------------------------------------------------
c  Input labelling information for mesh plotting
      call setplotconfig(mtitle, 'y', 'n', 'y', 'y', 'y', 'n', 
     +                   intlab, disp_border_plot)

      curstate = STATE_MESHPLOT_00
      newmenu = 11

      ref_pt(1) = -1.0
      ref_pt(2) = 1.0

      call set_menu(newmenu, ref_pt)
      call read_menu(option)

      do while (.not. quit)
         if (curstate .eq. STATE_MESHPLOT_00) then
             if (option .eq. 1) then
                 curstate = STATE_MESHPLOT_01

                 ref_pt(1) = -1.0
                 ref_pt(2) = 1.0

                 newmenu = 2
             else if (option .eq. 2) then
                      call annotate_plot()
                      curstate = STATE_MESHPLOT_00

                      ref_pt(1) = -1.0
                      ref_pt(2) = 1.0
 
                      newmenu = 11
             else if (option .eq. 3) then
                      curstate = STATE_MESHPLOT_02

                      ref_pt(1) = MENUBAR_OPT_WIDTH_FRAC * (option - 1)
     +                            - 1.0
                      ref_pt(2) = 1.0

                      newmenu = 7
             else if (option .eq. 4) then
                      curstate = STATE_MESHPLOT_03

                      ref_pt(1) = MENUBAR_OPT_WIDTH_FRAC * (option - 1)
     +                            - 1.0
                      ref_pt(2) = 1.0

                      newmenu = 5

             end if
         else if (curstate .eq. STATE_MESHPLOT_01) then
                  if (option .eq. 1) then
                      if (nodplot .eq. 'y') then
                          nodplot = 'n'
                      else
                          nodplot = 'y'
                      end if
                  else if (option .eq. 2) then
                           if (nodnum .eq. 'y') then
                               nodnum = 'n'
                           else
                               nodnum = 'y'
                           end if
                  else if (option .eq. 3) then
                           if (elplot .eq. 'y') then
                               elplot = 'n'
                           else
                               elplot = 'y'
                            end if
                  else if (option .eq. 4) then
                           if (boundplt .eq. 'y') then
                               boundplt = 'n'
                           else
                               boundplt = 'y'
                           end if
                  end if

                  curstate = STATE_MESHPLOT_00
                  newmenu = 11

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0
         else if (curstate .eq. STATE_MESHPLOT_02) then
                  curstate = STATE_MESHPLOT_00
                  newmenu = 11

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0

                  if (option .eq. 1) then
                      call update_meshplot()
                  else if (option .eq. 2) then
                      call clear_plot_area()
                      call clear_info_area()
                  else if (option .eq. 3) then
                           call generate_hardcopy(iunit, iout,
     +                                            hcopyfname)
                  else if (option .eq. 4) then
                           call generate_pict_file(iunit, iout,
     +                                             hcopyfname)
                  else if (option .eq. 5) then
                           quit = .TRUE.
                           curstate =  STATE_NONGRAPH
                           newmenu = MENU_NO_MENU
                  end if
         else if (curstate .eq. STATE_MESHPLOT_03) then
                  call window_definition(option)

                  curstate = STATE_MESHPLOT_00
                  newmenu = 11

                  ref_pt(1) = -1.0
                  ref_pt(2) = 1.0 
         end if

         call set_menu(newmenu, ref_pt)

         if (newmenu .ne. MENU_NO_MENU) then
             call read_menu(option)
         end if
      end do

      return
      end

*-----------------------------------------------------------------------
      subroutine update_meshplot
*-----------------------------------------------------------------------

      use posttypes
      use glob_vars

      include 'pubfunc.h'

c-----------------------------------------------------------------------
c     Setup window       

      call hf_flush_contents('?Picture/plot...', 'geometry')
      call hf_flush_contents('?Picture/plot/annots...', 'text, lines')

      call setup_window(xwmin,ywmin,xwmax,ywmax)
      call hf_open_segment('?Picture/plot')

c     call setup_window(xwmin,ywmin,xwmax,ywmax)
c
c     call hf_open_segment('?Picture/plot')

c---Plot nodes and nodes numbers if requested-------------------------
      if (nodplot.eq.'y') call plotn(x,y,xwmin, ywmin, xwmax, ywmax,
     +                               nnodes,nodnum)
c
c---Draw elements if requested----------------------------------------
      if (elplot.eq.'y') call eplot(x,y,nnodes,nel,node,intrash)
c
c---Draw boundary if requested----------------------------------------
      if (boundplt.eq.'y') call border(x,y,nnodes,nbe,nbnc,idash)
c-----------------------------------------------------------------------

      call display_annotations()

      call hf_close_segment()

      call clear_info_area()

      call display_plot_status(PLOTTYPE_MESHPLOT)

      call update_display()

      return
      end
