*-------------------------------------------------------------------------------------------
* posttypes.f
*
* Definition of some additional data types used in the program.
*
* Author: Rodrigo A. Marin
*-------------------------------------------------------------------------------------------

      module posttypes

      type intersection
          integer elnum
          integer numint
          integer intertype

c          Fields for plane-edge intersection type.

          integer edgenum
          double precision t1(2)

c          Fields for plane-triangle intersection type.

          double precision lambda(3)
          double precision t2(2)
      end type intersection

c     The intersection structure contains the data concerning line intersections between the
c     topology edges and the cutting plane for the calculation of slice plots.
c
c     elnum	: Number of the element having the intsersected edge.
c     intertype : Type of intersection plane-edge or plane-element (triangle)
c     edgenum	: Number of the intersected edge (1..3)
c     numint    : Number of intersections (1 or 2)
c     t1	: Value of the parameter for the intersection point(s) on the edge.
c     lambda    : Baricentric coordinates of the intersection point between the plane and the
c                 finite element (triangle).
c     t2	: Value of the parameter for the intersection point(s) on the cutting plane base line.

      type menu_spec
          character name*(80)
          integer   level
          integer   numopt
          character labels(10)*(32)
          logical   active(10)
          real      extents(4)
      end type menu_spec

c     The menu_spec structure contains the specification of a menu entry.
c
c     level	: The level of the menu in the menu hierarchy
c     numopt    : Number of options in the menu
c     labels	: Options labels
c     active    : For each option, .TRUE. if the option is selectable.
c     extents   : Absolute extents of the menu.

      type annot_spec
          logical available
          integer ent_type

          real posx, posy
          character str*(80)

          real posx1, posy1
          real posx2, posy2
      end type annot_spec
          
      end module posttypes
