      subroutine showiter(usol, uin, uout)

      use posttypes
      use glob_vars

      include 'pubfunc.h'

*-----------------------------------------------------------------------
* Displays the iteration numbers and corresponding times available in
* the current solution file.
*
* usol: Unit associated to the solution file
* uin: Standard input unit
* uout: Standard outoput unit
*
* Author: Rodrigo A. Marin
* Date:   November 16 1992
*-----------------------------------------------------------------------

      integer usol, uin, uout

      integer j
      integer nlin
      integer option

      logical err
      logical quit
      character prompt*(MAXPROMPTLENGTH)

      rewind(usol)

      call binread1(casvel,tsol,tliq, taprn1, taprw1, rmolng,
     +              rtitle,mtitle,MAXN,nn,nns,nbes, usol,uout)

      write(uout, *)
      write(uout, *) 'Available data for Solution File are:'
      write(uout, *)
      write(uout, *) '      Iteration #             Time' //
     +               '         Z-Position'
      write(uout, *) '      -----------             ----' //
     +               '         ----------'
      write(uout, *)
      
      j = 1
      nlin = 0
      err = .FALSE.
      quit = .FALSE.

      do while ((j .le. MAXITERATIONS) .and. (.not. err) .and. 
     +          (.not. quit))
        call binread2(t, ut, vt, sigma, epsln, evp, seff, epefft, eeff,
     +                epdot, uts, ratio, e0, fa, tle, 
     +                elastic, eflow, dmgcrt, emod, ctime, nn, nns, 
     +                itnum, err, usol, uout)
        
        if (.not. err) then
            write(uout, 150) itnum, ctime, ctime*casvel
            nlin = nlin + 1

            if (nlin .eq. page_length) then
                call readmenu(7, option, uin, uout)

                if (option .eq. 2) then
                    quit = .TRUE.
                else
                    nlin = 0
                    write(uout, *)
                    write(uout, *) '      Iteration #             Time'
     +                             // '         Z-Position'
                    write(uout, *) '      -----------             ----' //
     +                             // '         ----------'
                    write(uout, *)
                end if
            end if
        end if
      end do 

      if ((j .gt. MAXITERATIONS) .or. (err)) then
          write(uout, *)
          write(uout, *)
          prompt = 'Press any key to continue...'
          call pause(prompt, strlen(prompt), uin, uout)
      end if

      return
150   format(8x,i4,12x,f12.5,4x,f12.5)
      end
