************************************************************************
*                                                                      *
*                     SUBROUTINE TAPER                                 *
*                                                                      *
************************************************************************
c
c  This subroutine contains the equations of the walls
c    of the mold so that the deflections can be calculated 
c    from this.
c
      subroutine taper(xc,yc,zcurrent,wall,distor,np,intrash)
      
      use posttypes
      use glob_vars

      include 'pubfunc.h'
c
c
      z = zcurrent
      if(ctime.lt.0.08.and.isimul.eq.1) then
          wall = 0.0
          distor = 0.0
          return  
      endif
	itaper = 2
c
c  This data fit from Brimacombe's billet caster work.
c          if(z.le.0.05) distor = 0.001*z
c          if(z.gt.0.05) distor = -1.1111e-4*z + 5.55555e-5
c          if(z.gt.0.30) distor = 2.2222e-5
c          if(np.eq.1) distor = distor / 4.5
c
c  This subroutine calculates distortion from Doug/Moitra's Model
c   Using ABAQUS for the distortion of the continuous casting mold
c
c
c
  	if (np .eq. 1) then
 	  z1 = 0.05
 	  z2 = 0.35
 	  z3 = 0.70
        d1= -0.59101 + 4.5711*xc - 5.7457*xc**2
        d2= -0.36902 + 5.1584*xc - 6.3157*xc**2
        d3= -0.45732 + 2.2348*xc - 2.4835*xc**2
        den=(z2-z1)*(z3-z2)*(z1-z3)
        a2=(d1*(z3*z3-z2*z2) + d2*(z1*z1-z3*z3) + d3*(z2*z2-z1*z1))/den
        a3=(d1*z2 - d2*z1 + d2*z3 - d3*z2 + d3*z1 - d1*z3)/den
        a1= d1 - a2*z1 - a3*z1*z1
        distor =-(a1 + a2*z + a3*z**2)*1e-3
c
c       Calculate distortion for narrow face (need z)
c
        elseif (np .eq. 2) then
         distor = -(-1.8443 + 6.5220*z - 7.9158*z**2 + 1.8443)*1e-3 
        endif
c
c	For Ideal Taper The distortion Should be set to Zero
c
	if (itaper .eq. 1) distor=0.
c
c
c  This taper is currently used on the ARMCO BUTLER Caster
c
      if (itaper .eq. 2) then
c         rmolng = .65
c
	if(np.eq.1) then
c         taprw1 = 0.0010
	  wall = taprw1 * (ymax-ymin) * z / rmolng
	elseif(np.eq.2) then
c	  taprn1 = 0.0070
	  wall = taprn1 * (xmax-xmin) * z / rmolng
	endif
c
      elseif (itaper .eq. 3) then
c
c      if(z.le. zpos(1)) then
c        if(np.eq.1) then
c           tapr = 0.005
c          wall = taprw * (ymax-ymin) * z / rmolng
c        elseif(np.eq.2) then
c           tapr = 0.0130
c          wall = taprn(1) * (xmax-xmin) * z / rmolng
c        endif
c      elseif(z.ge. zpos(1).and.z.le. zpos(2)) then
c        if(np.eq.1) then
c           tapr = 0.005
c          wall = taprw * (ymax-ymin) * (z-zpos(1)) / rmolng +
c    +                 taprw*zpos(1)*(ymwax-ymin)/rmolng
c        elseif(np.eq.2) then
c          wall = taprn(2) * (xmax-xmin) * (z-zpos(1)) / rmolng +
c    +                 taprn(2)*zpos(1)*(xmax-xmin)/rmolng
c        endif
c      elseif(z.ge. zpos(2)) then
c        if(np.eq.1) then
c           tapr = 0.005
c          wall = taprw * (ymax-ymin) * (z-zpos(2)) / rmolng +
c    +                 taprw*zpos(2)*(ymax-ymin)/rmolng
c        elseif(np.eq.2) then
c           tapr = 0.004
c          wall = taprn(3) * (xmax-xmin) * (z-zpos(2)) / rmolng +
c    +                 taprn(1)*zpos(1)*(xmax-xmin)/rmolng   +
c    +                 taprn(2)*(zpos(2)-zpos(1))*(xmax-xmin)/rmolng
c        endif
c      endif
c
cideal  This taper determines the ideal taper by having the wall follow the
cideal       average over the center half of the slab's wide face movement.
cidealsmall = 1.e-6 + 2.e-5*ctime
cidealif(small.gt.5.e-5) small = 5.e-5
cidealif(ianalyz.eq.1.or.nn.lt.600) then
cideal   wall = 0.0
cidealelse
cidealif(np.eq.1) then
cideal   closeshl = avehw1 + distor - small
cideal   wall = closeshl
cidealelseif(np.eq.2) then
cideal   closeshl = ut(20) + distor - small
cideal   wall = closeshl
cidealendif
cidealendif
c
cidlinIdeal taper on Narrow Face only
c
      elseif (itaper .eq. 1) then
c
c	if(ctime.gt.4.0) then
          if(np.eq.1) then
            tapr = 0.005
            wall = tapr * (ymax-ymin) * z / rmolng
          elseif(np.eq.2) then
            small = 1.e-6 + 2.e-5*ctime
            if(small.gt.5.e-5) small = 5.e-5
c           wall = ut(nncen) - small
c
 	  endif
      endif
c
      return
      end
